Imports vPClient = Intergraph.GeoMedia.PClient
Imports tf = Microsoft.VisualBasic.FileIO.TextFieldParser
Public NotInheritable Class GeneralFuncions
    'Aquest procedimet extreu el valor del camp i taula demanats amb el filtre corresponent
    'Equivalent a la funci DLookup de VBA.
    '@para pFieldName = string que representa el nom del camp on estan les dades
    '@param pRecSource = string que representa la taula on son les dades
    '@param pCriteria = Expres de filtre per les dades
    Public Function DLookup(ByVal pFieldName As String, ByVal pRecSource As String, ByVal pCriteria As String) As Object
        Dim vConn As vPClient.Connection
        Dim vDB As GDO.GDatabase
        Dim vResultat As GDO.GRecordset
        Dim strSQL As String
        '=========================================================
        On Error GoTo Error_DLookup
        vConn = gobjGeoApp.Document.Connections(1)
        vDB = vConn.Database
        strSQL = "SELECT D." & pFieldName & " FROM " & pRecSource & " AS D WHERE " & pCriteria & ";"
        'Create a dynaset based on the record source or SQL string provided
        vResultat = vDB.OpenRecordset(strSQL, GDO.GConstants.gdbOpenDynaset)
        'Carreguem el primer registre, si existeix
        If Not vResultat.EOF And Not vResultat.BOF Then
            vResultat.MoveFirst()
            DLookup = vResultat.GFields(0).Value
        Else
            DLookup = 0
        End If

DLookup_Exit:
        vConn = Nothing
        vDB = Nothing
        vResultat = Nothing
        strSQL = Nothing
        Exit Function

Error_DLookup:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en DLookup", 64)
        Resume DLookup_Exit
    End Function

    'Aquest procedimet extreu el valor del camp i taula demanats amb el filtre corresponent
    'Equivalent a la funci DLookup de VBA.
    '@para pFieldName = string que representa el nom del camp on estan les dades
    '@param pRecSource = string que representa la taula on son les dades
    '@param pCriteria = Expres de filtre per les dades
    Public Function DCount(ByVal pFieldName As String, ByVal pRecSource As String, ByVal pCriteria As String) As Object
        Dim vConn As vPClient.Connection
        Dim vDB As GDO.GDatabase
        Dim vResultat As GDO.GRecordset
        Dim strSQL As String
        '=========================================================
        On Error GoTo Error_DCount
        vConn = gobjGeoApp.Document.Connections(1)
        vDB = vConn.Database
        If pCriteria = "" Then
            strSQL = "SELECT D." & pFieldName & " FROM " & pRecSource & " AS D;"
        Else
            strSQL = "SELECT D." & pFieldName & " FROM " & pRecSource & " AS D WHERE " & pCriteria & ";"
        End If
        'Create a dynaset based on the record source or SQL string provided
        vResultat = vDB.OpenRecordset(strSQL, GDO.GConstants.gdbOpenDynaset)
        'Carreguem el primer registre, si existeix
        If Not vResultat.EOF And Not vResultat.BOF Then
            vResultat.MoveLast()
            DCount = vResultat.RecordCount
        Else
            DCount = 0
        End If

DCount_Exit:
        vConn = Nothing
        vDB = Nothing
        vResultat = Nothing
        strSQL = Nothing
        Exit Function

Error_DCount:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en DLookup", 64)
        Resume DCount_Exit
    End Function

    'Aquest procedimet extreu les coordenades (X) per construir el arc i la linia que els uneix
    'per formar els sectors. La informaci que rep la funci s: l'ANGLE expressat com fracci entre
    'vots acumulats / total votants. El punt origen .El radi s un valor constant. S'avalua si l'angle
    's de 90 graus, inferior o superior. Com que per extreure la coordenada x s'utilitza el cosinus i 
    'aquest s negatiu per angles de ms de 90 graus (PI/2). Ara b aqui es volen construir els sectors
    'comenant a l'esquerra, per la qual cosa s'ha de canviar el signe del resultat de la frmula. El punt de
    'referncia s el origen
    '@param pOrigin = Expresa el punt d'origen amb els valors X, Y i Z
    '@param pAngle = numero doble que representa el valor del angle sobre 180 Vots/Votans. On votans representa els
    '@param pTipus = numero byte que representa el tipus de coordinada a extreure 1=RadiGran; 2=RadiPetit; 3=RadiRetols
    Public Function getCoordenadaX(ByVal pOrigin As PBasic.point, ByVal pAngle As Double, ByVal pTipus As Byte) As Double
        On Error GoTo Error_getCoordenadaX
        Dim vX As Double, vCoorX As Double
        Select Case pTipus
            Case 1
                vCoorX = Math.Cos(Math.PI * pAngle) * modCHARTSDATA.RADI_SECTOR
            Case 2
                vCoorX = Math.Cos(Math.PI * pAngle) * modCHARTSDATA.RADI_SECTOR_PETIT
            Case 3
                vCoorX = Math.Cos(Math.PI * pAngle) * modCHARTSDATA.RADI_RETOLS_SECTOR
        End Select
        Select Case pAngle
            Case 0.5 '90
                vX = pOrigin.X
            Case Is < 0.5 'Inferior a 90. El cosinus s positiu, per aqu volem que la coordenada 
                'aparegui a l'esquerra del origen
                vX = pOrigin.X - vCoorX
            Case Is > 0.5 'Superior a 90. El cosinus s negatiu, per aqu volem que la coordenada 
                'aparegui a la dreta del origen (- - = +)
                vX = pOrigin.X - vCoorX
        End Select

getCoordenadaX_Exit:
        getCoordenadaX = vX
        vX = Nothing
        Exit Function

Error_getCoordenadaX:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en DLookup", 64)
        Resume getCoordenadaX_Exit
    End Function

    'Aquest procedimet extreu les coordenades (Y) per construir el arc i la linia que els uneix
    'per formar els sectors. La informaci que rep la funci s: l'ANGLE expressat com fracci entre
    'vots acumulats / total votants. El punt origen .El radi s un valor constant. La funci sinus per
    'a angles entre 0 i 180 sempre s positiva oscillant entre 0 i 1
    '@param pOrigin = Expresa el punt d'origen amb els valors X, Y i Z
    '@param pAngle = numero doble que representa el valor del angle sobre 180 Vots/Votans. On votans representa els
    '@param pTipus = numero byte que representa el tipus de coordinada a extreure 1=RadiGran; 2=RadiPetit; 3= Radi Rtols
    Public Function getCoordenadaY(ByVal pOrigin As PBasic.point, ByVal pAngle As Double, ByVal pTipus As Byte) As Double
        On Error GoTo Error_getCoordenadaY
        Dim vY As Double, vCoorY As Double
        Select Case pTipus
            Case 1
                vCoorY = (Math.Sin(Math.PI * pAngle) * modCHARTSDATA.RADI_SECTOR)
            Case 2
                vCoorY = (Math.Sin(Math.PI * pAngle) * modCHARTSDATA.RADI_SECTOR_PETIT)
            Case 3
                vCoorY = (Math.Sin(Math.PI * pAngle) * modCHARTSDATA.RADI_RETOLS_SECTOR)
        End Select
        vY = vCoorY + pOrigin.Y

getCoordenadaY_Exit:
        getCoordenadaY = vY
        vCoorY = Nothing
        vY = Nothing
        Exit Function

Error_getCoordenadaY:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en DLookup", 64)
        Resume getCoordenadaY_Exit
    End Function

    'Aquesta funci neteja els elements de la llegenda que no siguin fixes
    '@return boolean per indicar si ha acabar sense problemes = true
    Public Function Clean_Legend_Entries() As Boolean
        Dim i As Integer
        Dim vCorrectFunction As Boolean = True
        '=========================================================
        On Error GoTo Error_Clean_Legend_Entries
        '==================================================
        'Collocar les entitats al mapview
        '==================================================
        Dim MV As Intergraph.GeoMedia.MapviewLib.GMMapView
        Dim objRLE As PView.LegendEntry
        MV = gobjGeoApp.ActiveWindow.Mapview
        '============================================
        ' Comencem amb la inclusi a la llegenda
        '============================================
        objRLE = CreateObject("Geomedia.LegendEntry")
        For i = MV.Legend.LegendEntries.Count To 1 Step -1
            objRLE = MV.Legend.LegendEntries(i)
            Select Case objRLE.Name
                Case "NomComarques", "Comarques"
                Case Else
                    MV.Legend.LegendEntries.Remove(i)
            End Select
        Next
        MV.Fit()
        MV.Legend.Fit()
        '====================================================

Clean_Legend_Entries_Exit:
        objRLE = Nothing
        MV = Nothing
        Clean_Legend_Entries = vCorrectFunction
        Exit Function

Error_Clean_Legend_Entries:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Clean Legend", 64)
        vCorrectFunction = False
        'Resume Next
        Resume Clean_Legend_Entries_Exit
    End Function


    'Aquest procedimet esborra les dades de les taules contenidores dels elements grafics
    'tret dels elements de base com les comarques i els noms de les comarques.
    '@return boolean indicant si la operativa ha estat correcta
    Public Function Clean_Data_Table(ByVal pTaula As String, Optional ByVal pAnyo As Integer = 0) As Boolean
        Dim vConn As vPClient.Connection
        Dim vDB As GDO.GDatabase
        Dim vRS As GDO.GRecordset
        Dim i As Integer
        Dim strSQL As String
        Dim vCorrectFunction As Boolean = True
        '=========================================================
        On Error GoTo Error_Clean_Data_Tables
        vConn = gobjGeoApp.Document.Connections(1)
        '=================================================
        vDB = vConn.Database
        If pAnyo > 0 Then
            strSQL = "SELECT * FROM " & pTaula & " P WHERE P.ANYO=" & pAnyo & ";"
        Else
            strSQL = "SELECT * FROM " & pTaula & ";"
        End If
        vRS = vDB.OpenRecordset(strSQL, GDO.GConstants.gdbOpenDynaset)
        If Not vRS.BOF And Not vRS.EOF Then
            vRS.MoveLast()
            For i = vRS.RecordCount To 1 Step -1
                vRS.Delete()
                vRS.MovePrevious()
            Next
        End If
        '=================================================

Clean_Data_Table_Exit:
        vRS = Nothing
        vDB = Nothing
        vConn = Nothing
        Clean_Data_Table = vCorrectFunction
        Exit Function

Error_Clean_Data_Tables:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Clean Tables", 64)
        vCorrectFunction = False
        'Resume Next
        Resume Clean_Data_Table_Exit
    End Function

    'Aquest procedimet esborra les dades de les taules contenidores dels elements grafics
    'tret dels elements de base com les comarques i els noms de les comarques.
    '@param pNameFile = ruta i nom del arxiu a tractar
    '@return boolean indicant si la operativa ha estat correcta
    Public Function Read_Data_File(ByVal pNameFile As String, ByVal pNameTable As String) As Boolean
        Dim vConn As vPClient.Connection
        Dim vDB As GDO.GDatabase
        Dim vRS As GDO.GRecordset
        Dim row As String(), strSQL As String, i As Integer
        Dim vImportacioCorrecta As Boolean = True
        On Error GoTo Error_read_Data_File
        Using tf As New Microsoft.VisualBasic.FileIO.TextFieldParser(pNameFile)
            tf.TextFieldType = FileIO.FieldType.Delimited
            tf.SetDelimiters(";")
            vConn = gobjGeoApp.Document.Connections(1)
            '=================================================
            vDB = vConn.Database
            strSQL = "SELECT * FROM " & pNameTable & ";"
            vRS = vDB.OpenRecordset(strSQL, GDO.GConstants.gdbOpenDynaset)
            With vRS
                While Not tf.EndOfData
                    row = tf.ReadFields()
                    i = 0
                    .AddNew()
                    For Each field As String In row
                        .GFields(i).Value = field
                        i = i + 1
                    Next
                    .Update()
                End While
            End With
        End Using

Read_Data_File_Exit:
        row = Nothing
        vRS = Nothing
        vDB = Nothing
        vConn = Nothing
        Read_Data_File = vImportacioCorrecta
        Exit Function

Error_read_Data_File:
        'Display the error and get out
        vImportacioCorrecta = False
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " Llegint arxiu de dades", 64)
        'Resume Next
        Resume Read_Data_File_Exit
    End Function

    'Aquest procedimet Arxiva les dades de les taules temporals a les taules definitives
    '@param pTaulaFrom = nom de la taula origen de les dades. Taula temporal
    '@param pTaulaTo = nom de la taula dest de les dades.
    '@return boolean indicant si la operativa ha estat correcta
    Public Function Load_Data_Tmp(ByVal pTaulaFrom As String, ByVal pTaulaTo As String) As Boolean
        Dim vConn As vPClient.Connection
        Dim vDB As GDO.GDatabase
        Dim vRSFrom As GDO.GRecordset, vRSTo As GDO.GRecordset
        Dim row As String(), strSQL As String, i As Integer, j As Integer
        Dim vImportacioCorrecta As Boolean = True
        On Error GoTo Error_Load_Data_File
        vConn = gobjGeoApp.Document.Connections(1)
        '=================================================
        vDB = vConn.Database
        strSQL = "SELECT * FROM " & pTaulaFrom & ";"
        vRSFrom = vDB.OpenRecordset(strSQL, GDO.GConstants.gdbOpenDynaset)
        vRSTo = vDB.OpenRecordset(pTaulaTo, GDO.GConstants.gdbOpenDynaset)
        If Not vRSFrom.EOF And Not vRSFrom.BOF Then
            vRSFrom.MoveLast() : vRSFrom.MoveFirst()
            For i = 1 To vRSFrom.RecordCount
                vRSTo.AddNew()
                For j = 0 To vRSFrom.GFields.Count - 1
                    vRSTo.GFields(j).Value = vRSFrom.GFields(j).Value
                Next
                vRSTo.Update()
                vRSFrom.MoveNext()
            Next
        End If

Load_Data_File_Exit:
        row = Nothing
        vRSFrom = Nothing
        vRSTo = Nothing
        vDB = Nothing
        vConn = Nothing
        Load_Data_Tmp = vImportacioCorrecta
        Exit Function

Error_Load_Data_File:
        'Display the error and get out
        vImportacioCorrecta = False
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " Llegint arxiu de dades", 64)
        'Resume Next
        Resume Load_Data_File_Exit
    End Function
End Class
