Imports vPClient = Intergraph.GeoMedia.PClient
Public NotInheritable Class GraphicFunctions
    'Aquest procedimet extreu les coordenades del centre de la comarca de forma aproximada amb la finalitat
    'de que ens serveixin desprs per produir un desplaament de la geometria representativa del grfic.
    '@para pObjecte = objecte blob que representa la geometria capturada de la BD
    '@param pKeyComarca = string que representa la clau de la comarca.
    '@param pX = referncia per tornar el valor de la coordenada X.
    '@param pY = referncia per tornar el valor de la coordenada Y.
    Private Structure LabelGraphic
        Dim vX As Double
        Dim vStr As String
        Dim vStrGran As String
    End Structure

    Public Sub calculaPuntoOrigen(ByVal pObjecte As Object, ByVal pkeyComarca As String, ByRef pX As Double, ByRef pY As Double, _
        ByRef pXOrigen As Double, ByRef pYOrigen As Double, ByRef pMaxX As Double, ByRef pMaxY As Double)
        Dim GSS As vPClient.GeometryStorageService
        Dim vBoundary As PBasic.BoundaryGeometry, vPolygon As PBasic.PolygonGeometry
        Dim vColection As PBasic.GeometryCollection, vObj As Object, isBoundary As Boolean
        Dim vCoorX As Double, vCoorY As Double, vColectionObject As Long
        Dim vXOrigen As Double, vYOrigen As Double, vMaxX As Double, vMaxY As Double
        Dim vGeneralFunc = New GeneralFuncions
        '===============================================================
        On Error GoTo Error_calculaPuntoOrigen
        Dim i As Long, vNumObjectes As Long, vObjecteEscollit As Long, tipusGeometria As String
        GSS = gobjGeoApp.CreateService("GeoMedia.GeometryStorageService")
        'tractem cada geometria d'una manera diferent
        Select Case vGeneralFunc.DLookup("[TIPUS_GEOMETRIA]", "COMARQUES", "D.[COMARCA]=""" & pkeyComarca & """")
            Case "GeometryCollection"
                vObj = pObjecte
                GSS.StorageToGeometry(vObj, vColection)
                vNumObjectes = 0 : vObjecteEscollit = 1 : isBoundary = False
                For i = 1 To vColection.Count
                    Select Case vColection.Item(i).type
                        Case "PolygonGeometry"
                            vPolygon = vColection.Item(i)
                            If vPolygon.Points.Count > vNumObjectes Then
                                vNumObjectes = vPolygon.Points.Count
                                vObjecteEscollit = i
                            End If
                        Case "BoundaryGeometry"
                            isBoundary = True
                            vColectionObject = i
                    End Select
                Next i
                If Not isBoundary Then
                    vPolygon = vColection.Item(vObjecteEscollit)
                    GSS.GeometryToStorage(vPolygon, vObj)
                Else
                    vBoundary = vColection.Item(vColectionObject)
                    vPolygon = vBoundary.Exterior
                    GSS.GeometryToStorage(vPolygon, vObj)
                End If
            Case "BoundaryGeometry"
                vObj = pObjecte
                GSS.StorageToGeometry(vObj, vBoundary)
                vPolygon = vBoundary.Exterior
                GSS.GeometryToStorage(vPolygon, vObj)
            Case "PolygonGeometry"
                'no cal fer transformaci prvia
                vObj = pObjecte
        End Select
        ExtraeCentroPoligon(vObj, vCoorX, vCoorY, vXOrigen, vYOrigen, vMaxX, vMaxY)
        pX = vCoorX : pY = vCoorY
        pXOrigen = vXOrigen : pYOrigen = vYOrigen
        pMaxX = vMaxX : vMaxY = vMaxY

calculaPuntoOrigen_Exit:
        GSS = Nothing
        vBoundary = Nothing : vPolygon = Nothing
        vColection = Nothing : vObj = Nothing : isBoundary = Nothing
        vCoorX = Nothing : vCoorY = Nothing : vColectionObject = Nothing
        vXOrigen = Nothing : vYOrigen = Nothing : vMaxX = Nothing : vMaxY = Nothing
        Exit Sub

Error_calculaPuntoOrigen:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en calculaPuntoOrigen", 64)
        Resume calculaPuntoOrigen_Exit
    End Sub
    'Aquest procedimet extreu les coordenades del centre del POLIGON QUE S'ENVIA COM A PARAMETRE
    'de que ens serveixin desprs per produir un desplaament de la geometria representativa del grfic.
    '@para pObjecte = objecte blob que representa la geometria capturada de la BD
    '@param pX = referncia per tornar el valor de la coordenada X.
    '@param pY = referncia per tornar el valor de la coordenada Y.
    '@param pXOrigen = referncia del punt origen X. Es tracta del valor inferior de X
    '@param pYOrigen = referncia del punt origen Y. Es la Y ms baixa
    '@param pMaxX = referncia de la X ms a la dreta
    '@param pMaxY = referncia de la Y ms alta
    Public Sub ExtraeCentroPoligon(ByVal pObjecte As Object, ByRef pX As Double, ByRef pY As Double, _
    ByRef pXOrigen As Double, ByRef pYOrigen As Double, ByRef pMaxX As Double, ByRef pMaxY As Double)
        Dim GSS As vPClient.GeometryStorageService
        Dim vPolygon As PBasic.PolygonGeometry
        Dim maxCoorX As Double, maxCoorY As Double, minCoorX As Double, minCoorY As Double
        Dim i As Long
        '===============================================================
        On Error GoTo Error_ExtraeCentroPoligon
        GSS = gobjGeoApp.CreateService("GeoMedia.GeometryStorageService")
        GSS.StorageToGeometry(pObjecte, vPolygon)
        maxCoorX = vPolygon.Points.Item(1).X : maxCoorY = vPolygon.Points.Item(1).Y
        minCoorX = vPolygon.Points.Item(1).X : minCoorY = vPolygon.Points.Item(1).Y
        For i = 2 To vPolygon.Points.Count
            If vPolygon.Points.Item(i).X > maxCoorX Then
                maxCoorX = vPolygon.Points.Item(i).X
            ElseIf vPolygon.Points.Item(i).Y > maxCoorY Then
                maxCoorY = vPolygon.Points.Item(i).Y
            ElseIf vPolygon.Points.Item(i).X < minCoorX Then
                minCoorX = vPolygon.Points.Item(i).X
            ElseIf vPolygon.Points.Item(i).Y < minCoorY Then
                minCoorY = vPolygon.Points.Item(i).Y
            End If
        Next i
        pXOrigen = minCoorX
        pYOrigen = minCoorY
        pMaxX = maxCoorX
        pMaxY = maxCoorY
        pX = minCoorX + ((maxCoorX - minCoorX) / 2)
        pY = minCoorY + ((maxCoorY - minCoorY) / 2)

ExtraeCentroPoligon_Exit:
        GSS = Nothing
        vPolygon = Nothing
        maxCoorX = Nothing : maxCoorY = Nothing : minCoorX = Nothing : minCoorY = Nothing
        i = Nothing
        Exit Sub

Error_ExtraeCentroPoligon:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en ExtraeCentroPoligon", 64)
        Resume ExtraeCentroPoligon_Exit
    End Sub

    'Aquest procedimet construeix el quadre grafic de linies i les linies. Si hi ha error ho torna
    '@param pComarca = Codi de la comarca de la que es construeix la geometria
    '@param pOrigen = objecte que representa el punt d'origen per construir la geometria. Aquest punt
    '                 origen el tractem per que comenci ms amunt i a sota hi cpigan els rtols de Partit
    '@param pConvocatories = nombre de convocatories a tractar
    Public Function Build_LineChart(ByVal pComarca As String, ByVal pOrigen As PBasic.point, _
    ByVal pConvocatories As Integer)
        Dim vConn As vPClient.Connection
        Dim vGraficPipe As vPClient.OriginatingPipe
        Dim vRS As GDO.GRecordset, vRS2 As GDO.GRecordset
        Dim GSS As vPClient.GeometryStorageService
        Dim vObj As Object
        Dim vPunts As New PBasic.Points, vPunt As New PBasic.point, vPuntText As New PBasic.point
        Dim vPunt01 As PBasic.point, vPunt02 As PBasic.point, vPunt03 As PBasic.point
        Dim vPunt04 As PBasic.point, vPunt05 As PBasic.point, vPunt06 As PBasic.point
        Dim vPuntIniFin As PBasic.point
        Dim vLinia00h As New PBasic.LineGeometry 'Per les horitzontals
        Dim vLinia01h As New PBasic.LineGeometry
        Dim vLinia02h As New PBasic.LineGeometry
        Dim vLinia03h As New PBasic.LineGeometry
        Dim vLinia04h As New PBasic.LineGeometry
        Dim vLinia01v As New PBasic.LineGeometry 'Per les verticals
        Dim vLinia02v As New PBasic.LineGeometry
        Dim vLinia03v As New PBasic.LineGeometry
        Dim vLinia04v As New PBasic.LineGeometry
        Dim vPoligon As New PBasic.PolygonGeometry
        Dim vColeccio As New PBasic.GeometryCollection
        Dim vX As Double, vY As Double, vZ As Double, i As Integer, j As Integer
        Dim vCorrectGrafic As Boolean = True, vNameComarca As String, vGFuncions = New GeneralFuncions
        '=========================================================
        On Error GoTo Error_Build_LineChart
        'Construm el rectangle gran
        vX = pOrigen.X : vY = pOrigen.Y : vZ = pOrigen.Z
        vConn = gobjGeoApp.Document.Connections(1)
        GSS = gobjGeoApp.CreateService("GeoMedia.GeometryStorageService")
        vPunt = gobjGeoApp.CreateService("GeoMedia.Point")
        vPunt01 = gobjGeoApp.CreateService("GeoMedia.Point")
        vPunt02 = gobjGeoApp.CreateService("GeoMedia.Point")
        vPunt03 = gobjGeoApp.CreateService("GeoMedia.Point")
        vPunt04 = gobjGeoApp.CreateService("GeoMedia.Point")
        vPunt05 = gobjGeoApp.CreateService("GeoMedia.Point")
        vPunt06 = gobjGeoApp.CreateService("GeoMedia.Point")
        vPuntText = gobjGeoApp.CreateService("GeoMedia.Point")
        vPuntIniFin = gobjGeoApp.CreateService("GeoMedia.Point")
        vPunts = gobjGeoApp.CreateService("GeoMedia.Points")
        vLinia00h = gobjGeoApp.CreateService("GeoMedia.LineGeometry")
        vLinia01h = gobjGeoApp.CreateService("GeoMedia.LineGeometry")
        vLinia02h = gobjGeoApp.CreateService("GeoMedia.LineGeometry")
        vLinia03h = gobjGeoApp.CreateService("GeoMedia.LineGeometry")
        vLinia04h = gobjGeoApp.CreateService("GeoMedia.LineGeometry")
        vLinia01v = gobjGeoApp.CreateService("GeoMedia.LineGeometry")
        vLinia02v = gobjGeoApp.CreateService("GeoMedia.LineGeometry")
        vLinia03v = gobjGeoApp.CreateService("GeoMedia.LineGeometry")
        vLinia04v = gobjGeoApp.CreateService("GeoMedia.LineGeometry")
        vPoligon = gobjGeoApp.CreateService("GeoMedia.PolygonGeometry")
        vColeccio = gobjGeoApp.CreateService("GeoMedia.GeometryCollection")
        'Per al primer polgon
        '===============================================
        For i = 1 To 5 ' Sn cinc punts ja que el primer i l'ultim coincideixen
            vPunt.X = pOrigen.X : vPunt.Y = pOrigen.Y : vPunt.Z = pOrigen.Z
            Select Case i 'Per als punts 1 i 5 es pren l'origen
                Case 2
                    vPunt.Y = pOrigen.Y + ALTURA_TOTAL_GRAFIC
                Case 3
                    vPunt.X = vPunt.X + AMPLADA_GRAFIC : vPunt.Y = vPunt.Y + ALTURA_TOTAL_GRAFIC
                Case 4
                    vPunt.X = pOrigen.X + AMPLADA_GRAFIC
            End Select
            vPoligon.Points.Add(vPunt)
        Next
        vColeccio.Add(vPoligon)
        'Construm les linies del rectangle
        'Per les horitzontals:
        vPunt = pOrigen
        For i = 0 To 80 Step 20
            Select Case i
                Case 0
                    vLinia00h.Start.X = vPunt.X : vLinia00h.Start.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia01h.Start.Z = vPunt.Z
                    vLinia00h.End.X = vPunt.X + AMPLADA_GRAFIC : vLinia00h.End.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia01h.End.Z = vPunt.Z
                    vColeccio.Add(vLinia00h)
                Case 20
                    vLinia01h.Start.X = vPunt.X : vLinia01h.Start.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia01h.Start.Z = vPunt.Z
                    vLinia01h.End.X = vPunt.X + AMPLADA_GRAFIC : vLinia01h.End.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia01h.End.Z = vPunt.Z
                    vColeccio.Add(vLinia01h)
                Case 40
                    vLinia02h.Start.X = vPunt.X : vLinia02h.Start.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia02h.Start.Z = vPunt.Z
                    vLinia02h.End.X = vPunt.X + AMPLADA_GRAFIC : vLinia02h.End.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia02h.End.Z = vPunt.Z
                    vColeccio.Add(vLinia02h)
                Case 60
                    vLinia03h.Start.X = vPunt.X : vLinia03h.Start.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia03h.Start.Z = vPunt.Z
                    vLinia03h.End.X = vPunt.X + AMPLADA_GRAFIC : vLinia03h.End.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia03h.End.Z = vPunt.Z
                    vColeccio.Add(vLinia03h)
                Case 80
                    vLinia04h.Start.X = vPunt.X : vLinia04h.Start.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia04h.Start.Z = vPunt.Z
                    vLinia04h.End.X = vPunt.X + AMPLADA_GRAFIC : vLinia04h.End.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia04h.End.Z = vPunt.Z
                    vColeccio.Add(vLinia04h)
            End Select
        Next
        'Per les Verticals
        vPunt = pOrigen
        Select Case pConvocatories
            Case 2
                For i = 2 To 4 Step 2
                    Select Case i
                        Case 2
                            vLinia01v.Start.X = vPunt.X + (AMPLADA_GRAFIC * i / 6) : vLinia01v.Start.Y = vPunt.Y + 5000 : vLinia01v.Start.Z = vPunt.Z
                            vLinia01v.End.X = vPunt.X + (AMPLADA_GRAFIC * i / 6) : vLinia01v.End.Y = vPunt.Y + 5000 + ALTURA_DATOS_EN_GRAFIC : vLinia01v.End.Z = vPunt.Z
                            vColeccio.Add(vLinia01v)
                        Case 4
                            vLinia02v.Start.X = vPunt.X + (AMPLADA_GRAFIC * i / 6) : vLinia02v.Start.Y = vPunt.Y + 5000 : vLinia02v.Start.Z = vPunt.Z
                            vLinia02v.End.X = vPunt.X + (AMPLADA_GRAFIC * i / 6) : vLinia02v.End.Y = vPunt.Y + 5000 + ALTURA_DATOS_EN_GRAFIC : vLinia02v.End.Z = vPunt.Z
                            vColeccio.Add(vLinia02v)
                    End Select
                Next
            Case 3
                For i = 25 To 75 Step 25
                    Select Case i
                        Case 25
                            vLinia01v.Start.X = vPunt.X + (AMPLADA_GRAFIC * i / 100) : vLinia01v.Start.Y = vPunt.Y + 5000 : vLinia01v.Start.Z = vPunt.Z
                            vLinia01v.End.X = vPunt.X + (AMPLADA_GRAFIC * i / 100) : vLinia01v.End.Y = vPunt.Y + 5000 + ALTURA_DATOS_EN_GRAFIC : vLinia01v.End.Z = vPunt.Z
                            vColeccio.Add(vLinia01v)
                        Case 50
                            vLinia02v.Start.X = vPunt.X + (AMPLADA_GRAFIC * i / 100) : vLinia02v.Start.Y = vPunt.Y + 5000 : vLinia02v.Start.Z = vPunt.Z
                            vLinia02v.End.X = vPunt.X + (AMPLADA_GRAFIC * i / 100) : vLinia02v.End.Y = vPunt.Y + 5000 + ALTURA_DATOS_EN_GRAFIC : vLinia02v.End.Z = vPunt.Z
                            vColeccio.Add(vLinia02v)
                        Case 75
                            vLinia03v.Start.X = vPunt.X + (AMPLADA_GRAFIC * i / 100) : vLinia03v.Start.Y = vPunt.Y + 5000 : vLinia03v.Start.Z = vPunt.Z
                            vLinia03v.End.X = vPunt.X + (AMPLADA_GRAFIC * i / 100) : vLinia03v.End.Y = vPunt.Y + 5000 + ALTURA_DATOS_EN_GRAFIC : vLinia03v.End.Z = vPunt.Z
                            vColeccio.Add(vLinia03v)
                    End Select
                Next
            Case 4
                For i = 20 To 80 Step 20
                    Select Case i
                        Case 20
                            vLinia01v.Start.X = vPunt.X + (AMPLADA_GRAFIC * i / 100) : vLinia01v.Start.Y = vPunt.Y + 5000 : vLinia01v.Start.Z = vPunt.Z
                            vLinia01v.End.X = vPunt.X + (AMPLADA_GRAFIC * i / 100) : vLinia01v.End.Y = vPunt.Y + 5000 + ALTURA_DATOS_EN_GRAFIC : vLinia01v.End.Z = vPunt.Z
                            vColeccio.Add(vLinia01v)
                        Case 40
                            vLinia02v.Start.X = vPunt.X + (AMPLADA_GRAFIC * i / 100) : vLinia02v.Start.Y = vPunt.Y + 5000 : vLinia02v.Start.Z = vPunt.Z
                            vLinia02v.End.X = vPunt.X + (AMPLADA_GRAFIC * i / 100) : vLinia02v.End.Y = vPunt.Y + 5000 + ALTURA_DATOS_EN_GRAFIC : vLinia02v.End.Z = vPunt.Z
                            vColeccio.Add(vLinia02v)
                        Case 60
                            vLinia03v.Start.X = vPunt.X + (AMPLADA_GRAFIC * i / 100) : vLinia03v.Start.Y = vPunt.Y + 5000 : vLinia03v.Start.Z = vPunt.Z
                            vLinia03v.End.X = vPunt.X + (AMPLADA_GRAFIC * i / 100) : vLinia03v.End.Y = vPunt.Y + 5000 + ALTURA_DATOS_EN_GRAFIC : vLinia03v.End.Z = vPunt.Z
                            vColeccio.Add(vLinia03v)
                        Case 80
                            vLinia04v.Start.X = vPunt.X + (AMPLADA_GRAFIC * i / 100) : vLinia04v.Start.Y = vPunt.Y + 5000 : vLinia04v.Start.Z = vPunt.Z
                            vLinia04v.End.X = vPunt.X + (AMPLADA_GRAFIC * i / 100) : vLinia04v.End.Y = vPunt.Y + 5000 + ALTURA_DATOS_EN_GRAFIC : vLinia04v.End.Z = vPunt.Z
                            vColeccio.Add(vLinia04v)
                    End Select
                Next
        End Select
        'Arxivem l'objecte a la BD
        GSS.GeometryToStorage(vColeccio, vObj)
        vConn.CreateOriginatingPipe(vGraficPipe)
        With vGraficPipe
            .Table = "GraficLinies"
            .GeometryFieldName = "Geometry"
            .Filter = "COMARCA='" & pComarca & "'"
        End With
        vRS = vGraficPipe.OutputRecordset
        If Not vRS.BOF And Not vRS.EOF Then
            vRS.MoveLast() : vRS.MoveFirst()
            With vRS
                .Edit()
                .GFields("Geometry").Value = vObj
                .Update()
            End With
        Else
            With vRS
                .AddNew()
                .GFields("COMARCA").Value = pComarca
                .GFields("Geometry").Value = vObj
                .Update()
            End With
        End If
        '==================================================
        'Collocar les entitats al mapview
        '==================================================
        Dim MV As Intergraph.GeoMedia.MapviewLib.GMMapView
        Dim objRLE As PView.LegendEntry
        Dim objPropertyTitle As New vPClient.GMProperty
        Dim objStyleService As New PView.StyleService
        Dim objstyle As PView.StyleDefinition = Nothing ' per al compost
        Dim objstyle1 As PView.StyleDefinition = Nothing ' pel l'rea
        Dim objstyle2 As PView.StyleDefinition = Nothing ' per al liniear
        Dim objstyleB As PView.StyleDefinition ' Boundary style
        Dim objstyleF As PView.StyleDefinition ' Specify fill color
        MV = gobjGeoApp.ActiveWindow.Mapview
        objStyleService.GetStyle("Compound Style", objstyle)
        'objStyleService.GetStyle("Area Style", objstyle1)
        objStyleService.GetStyle("Area Style", objstyle1)
        objstyle1 = objstyle.StyleDefinitions(0).StyleDefinitions(0)
        'Specify boundary style
        objstyleB = objstyle1.StyleDefinitions(0).StyleDefinitions(0)
        objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 35
        objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 0, 182)
        'Specify fill color
        objstyleF = objstyle1.StyleDefinitions(1).StyleDefinitions(0)
        objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(185, 231, 198)
        objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyTranslucency).Value = 35 'Translucidesa
        'Specify Line style
        objStyleService.GetStyle("Linear Style", objstyle2)
        objstyle2 = objstyle.StyleDefinitions(1).StyleDefinitions(0)
        objstyle2.StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 45
        objstyle2.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 0, 109)
        objstyle2.StyleProperties(PView.StylePropertyConstants.gmgroPropertySequenceType).Value = 5 'Segments
        '============================================
        ' Comencem amb la inclusi a la llegenda
        '============================================
        vNameComarca = vGFuncions.DLookup("[NOM_COMAR]", "COMARQUES", "D.[COMARCA]='" & pComarca & "'")
        objRLE = CreateObject("Geomedia.LegendEntry")
        objPropertyTitle.Name = "Title"
        objPropertyTitle.Value = "Grfic " & Trim(vNameComarca)
        With objRLE
            .Name = Trim(vNameComarca)
            .GeometryFieldName = "Geometry"
            .InputRecordset = vGraficPipe.OutputRecordset
            .Style = objstyle
            .PropertySet.Append(objPropertyTitle)
        End With
        MV.Legend.LegendEntries.Append(objRLE, 1)
        objRLE.LoadData()
        MV.Fit()
        MV.Legend.Fit()
        '====================================================

Build_LineChart_Exit:
        vX = Nothing : vY = Nothing : vZ = Nothing : vNameComarca = Nothing
        vObj = Nothing : vPunts = Nothing : vGFuncions = Nothing
        vPunt = Nothing : vPuntIniFin = Nothing : vPuntText = Nothing
        vPunt01 = Nothing : vPunt02 = Nothing : vPunt03 = Nothing
        vPunt04 = Nothing : vPunt05 = Nothing : vPunt06 = Nothing
        vLinia00h = Nothing
        vLinia01h = Nothing
        vLinia02h = Nothing
        vLinia03h = Nothing
        vLinia04h = Nothing
        vLinia01v = Nothing
        vLinia02v = Nothing
        vLinia03v = Nothing
        vLinia04v = Nothing
        vPoligon = Nothing
        vColeccio = Nothing
        '====================== Estils: prefixe s
        objstyle1 = Nothing
        objstyle2 = Nothing
        objstyleB = Nothing
        objstyleF = Nothing
        objstyle = Nothing
        '====================== Carpetes d'estil: prefixe f
        objPropertyTitle = Nothing
        objStyleService = Nothing
        objRLE = Nothing
        MV = Nothing
        '====================== Objectes de dades
        GSS = Nothing
        vGraficPipe = Nothing
        vRS = Nothing : vRS2 = Nothing
        vConn = Nothing
        Build_LineChart = vCorrectGrafic
        Exit Function

Error_Build_LineChart:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Build LineChart", 64)
        vCorrectGrafic = False
        'Resume Next
        Resume Build_LineChart_Exit
    End Function

    'Aquest procedimet construeix les polilinies representatives dels resultats de cada partit
    '@param pResultats() = array d'una estructura de dades que cont les dades electorals
    '@param pOrigen = objecte que representa el punt d'origen per construir la geometria
    '@param pComarca = Codi de la comarca de la que es construeix la geometria
    Public Function Build_LineOfParties(ByVal pResultats() As frmCHARTSDATA.ResultatsPartits, ByVal pOrigen As PBasic.point, _
    ByVal pComarca As String) As Boolean
        Dim vConn As vPClient.Connection
        Dim vGraficPipe As vPClient.OriginatingPipe
        Dim vRS As GDO.GRecordset
        Dim GSS As vPClient.GeometryStorageService
        Dim vObj As Object
        Dim vPunts As New PBasic.Points, vPunt As New PBasic.point
        Dim vPunt01 As PBasic.point, vPunt02 As PBasic.point
        Dim vPunt03 As PBasic.point, vPunt04 As PBasic.point
        Dim vPoliLinia As New PBasic.PolylineGeometry
        Dim strLabel As String 'Variable per recollir els vots de cada Partit
        Dim vX As Double, vY As Double, vZ As Double, i As Integer
        Dim vCorrectGrafic As Boolean = True
        Dim vNameComarca As String, vGFuncions = New GeneralFuncions
        '=========================================================
        On Error GoTo Error_Build_LineOfParties
        'Construm el rectangle gran
        vX = pOrigen.X : vY = pOrigen.Y : vZ = pOrigen.Z
        vConn = gobjGeoApp.Document.Connections(1)
        GSS = gobjGeoApp.CreateService("GeoMedia.GeometryStorageService")
        vPunt = gobjGeoApp.CreateService("GeoMedia.Point")
        vPunt01 = gobjGeoApp.CreateService("GeoMedia.Point")
        vPunt02 = gobjGeoApp.CreateService("GeoMedia.Point")
        vPunt03 = gobjGeoApp.CreateService("GeoMedia.Point")
        vPunt04 = gobjGeoApp.CreateService("GeoMedia.Point")
        vPunts = gobjGeoApp.CreateService("GeoMedia.Points")
        vPoliLinia = gobjGeoApp.CreateService("GeoMedia.PolylineGeometry")
        'Per les linies de resultats
        Select Case UBound(pResultats)
            Case 2
                For i = 0 To 1
                    Select Case i
                        Case 0
                            vPunt01.X = vX + (AMPLADA_GRAFIC * 2 / 6)
                            vPunt01.Y = vY + (ALTURA_DATOS_EN_GRAFIC * (pResultats(i).Vots / pResultats(i).Votans))
                            vPoliLinia.Points.Add(vPunt01)
                            strLabel = "Vots: " & pResultats(i).Anyo & "(" & Format(pResultats(i).Vots, "#,0.") & ")"
                        Case 1
                            vPunt02.X = vX + (AMPLADA_GRAFIC * 4 / 6)
                            vPunt02.Y = vY + (ALTURA_DATOS_EN_GRAFIC * (pResultats(i).Vots / pResultats(i).Votans))
                            vPoliLinia.Points.Add(vPunt02)
                            strLabel = strLabel & ", " & pResultats(i).Anyo & "(" & Format(pResultats(i).Vots, "#,0.") & ")"
                    End Select
                Next
            Case 3
                For i = 0 To 2
                    Select Case i
                        Case 0
                            vPunt01.X = vX + (AMPLADA_GRAFIC * 25 / 100)
                            vPunt01.Y = vY + (ALTURA_DATOS_EN_GRAFIC * (pResultats(i).Vots / pResultats(i).Votans))
                            vPoliLinia.Points.Add(vPunt01)
                            strLabel = "Vots: " & pResultats(i).Anyo & "(" & Format(pResultats(i).Vots, "#,0.") & ")"
                        Case 1
                            vPunt02.X = vX + (AMPLADA_GRAFIC * 50 / 100)
                            vPunt02.Y = vY + (ALTURA_DATOS_EN_GRAFIC * (pResultats(i).Vots / pResultats(i).Votans))
                            vPoliLinia.Points.Add(vPunt02)
                            strLabel = strLabel & ", " & pResultats(i).Anyo & "(" & Format(pResultats(i).Vots, "#,0.") & ")"
                        Case 2
                            vPunt03.X = vX + (AMPLADA_GRAFIC * 75 / 100)
                            vPunt03.Y = vY + (ALTURA_DATOS_EN_GRAFIC * (pResultats(i).Vots / pResultats(i).Votans))
                            vPoliLinia.Points.Add(vPunt03)
                            strLabel = strLabel & ", " & pResultats(i).Anyo & "(" & Format(pResultats(i).Vots, "#,0.") & ")"
                    End Select
                Next
            Case 4
                For i = 0 To 3
                    Select Case i
                        Case 0
                            vPunt01.X = vX + (AMPLADA_GRAFIC * 20 / 100)
                            vPunt01.Y = vY + (ALTURA_DATOS_EN_GRAFIC * (pResultats(i).Vots / pResultats(i).Votans))
                            vPoliLinia.Points.Add(vPunt01)
                            strLabel = "Vots: " & pResultats(i).Anyo & "(" & Format(pResultats(i).Vots, "#,0.") & ")"
                        Case 1
                            vPunt02.X = vX + (AMPLADA_GRAFIC * 40 / 100)
                            vPunt02.Y = vY + (ALTURA_DATOS_EN_GRAFIC * (pResultats(i).Vots / pResultats(i).Votans))
                            vPoliLinia.Points.Add(vPunt02)
                            strLabel = strLabel & ", " & pResultats(i).Anyo & "(" & Format(pResultats(i).Vots, "#,0.") & ")"
                        Case 2
                            vPunt03.X = vX + (AMPLADA_GRAFIC * 60 / 100)
                            vPunt03.Y = vY + (ALTURA_DATOS_EN_GRAFIC * (pResultats(i).Vots / pResultats(i).Votans))
                            vPoliLinia.Points.Add(vPunt03)
                            strLabel = strLabel & ", " & pResultats(i).Anyo & "(" & Format(pResultats(i).Vots, "#,0.") & ")"
                        Case 3
                            vPunt04.X = vX + (AMPLADA_GRAFIC * 80 / 100)
                            vPunt04.Y = vY + (ALTURA_DATOS_EN_GRAFIC * (pResultats(i).Vots / pResultats(i).Votans))
                            vPoliLinia.Points.Add(vPunt04)
                            strLabel = strLabel & ", " & pResultats(i).Anyo & "(" & Format(pResultats(i).Vots, "#,0.") & ")"
                    End Select
                Next
        End Select
        ' Arxivem l'objecte a la BD
        GSS.GeometryToStorage(vPoliLinia, vObj)
        vConn.CreateOriginatingPipe(vGraficPipe)
        With vGraficPipe
            Select Case UCase(Trim(pResultats(0).Partit))
                Case "PP"
                    .Table = "LiniaPp"
                Case "CIU"
                    .Table = "LiniaCiu"
                Case "ALTRES"
                    .Table = "LiniaAltres"
                Case "PSC"
                    .Table = "LiniaPsc"
                Case "ERC"
                    .Table = "LiniaErc"
                Case "IC_V"
                    .Table = "LiniaIcv"
            End Select
            .GeometryFieldName = "Geometry"
            .Filter = "COMARCA='" & pComarca & "'"
        End With
        vRS = vGraficPipe.OutputRecordset
        If Not vRS.BOF And Not vRS.EOF Then
            vRS.MoveLast() : vRS.MoveFirst()
            With vRS
                .Edit()
                .GFields("Geometry").Value = vObj
                .GFields("ETIQUETA").Value = strLabel
                .Update()
            End With
        Else
            With vRS
                .AddNew()
                .GFields("COMARCA").Value = pComarca
                .GFields("Geometry").Value = vObj
                .GFields("ETIQUETA").Value = strLabel
                .Update()
            End With
        End If
        '==================================================
        'Collocar les entitats al mapview
        '==================================================
        Dim MV As Intergraph.GeoMedia.MapviewLib.GMMapView
        Dim objRLE As PView.LegendEntry
        Dim objPropertyTitle As New vPClient.GMProperty
        Dim objStyleService As New PView.StyleService
        Dim objstyleL As PView.StyleDefinition
        MV = gobjGeoApp.ActiveWindow.Mapview
        objStyleService = gobjGeoApp.CreateService("GeoMedia.StyleService")
        objStyleService.GetStyle("Simple Line Style", objstyleL)
        With objstyleL
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 70
            Select Case UCase(Trim(pResultats(0).Partit))
                Case "PP"
                    objstyleL.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 220, 220)
                Case "CIU"
                    objstyleL.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(70, 70, 255)
                Case "ALTRES"
                    objstyleL.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(173, 123, 16)
                Case "PSC"
                    objstyleL.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 0, 0)
                Case "ERC"
                    objstyleL.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(249, 244, 0)
                Case "IC_V"
                    objstyleL.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 182, 0)
            End Select
        End With
        '============================================
        ' Comencem amb la inclusi a la llegenda
        '============================================
        vNameComarca = vGFuncions.DLookup("[NOM_COMAR]", "COMARQUES", "D.[COMARCA]='" & pComarca & "'")
        objRLE = CreateObject("Geomedia.LegendEntry")
        objPropertyTitle.Name = "Title"
        objPropertyTitle.Value = "Partit: " & UCase(Trim(pResultats(0).Partit))
        With objRLE
            .Name = UCase(Trim(pResultats(0).Partit))
            .GeometryFieldName = "Geometry"
            .InputRecordset = vGraficPipe.OutputRecordset
            .Style = objstyleL
            .PropertySet.Append(objPropertyTitle)
        End With
        MV.Legend.LegendEntries.Append(objRLE, 1)
        objRLE.LoadData()
        MV.Fit()
        MV.Legend.Fit()
        '====================================================

Build_LineOfParties_Exit:
        vX = Nothing : vY = Nothing : vZ = Nothing
        vObj = Nothing
        vPunts = Nothing : vPunt = Nothing
        vPunt01 = Nothing : vPunt02 = Nothing
        vPunt03 = Nothing : vPunt04 = Nothing
        vPoliLinia = Nothing
        '==============================================
        objstyleL = Nothing
        objStyleService = Nothing
        objPropertyTitle = Nothing
        objRLE = Nothing
        MV = Nothing
        '==============================================
        GSS = Nothing
        vGraficPipe = Nothing
        vRS = Nothing
        vConn = Nothing
        Build_LineOfParties = vCorrectGrafic
        Exit Function

Error_Build_LineOfParties:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Build Line Of Parties", 64)
        vCorrectGrafic = False
        'Resume Next
        Resume Build_LineOfParties_Exit
    End Function

    'Aquest procedimet construeix la etiqueta que es posa al mig del quadre o marc del grfic
    '@param pOrigen = objecte que representa el punt d'origen per construir la geometria
    '@param pComarca = codi de la comarca tractada
    '@param pConvocatoria = any de la convocatoria
    '@param pVotants = nombre de votants de la comarca
    Public Function Build_TextsOfArcChart(ByVal pOrigen As PBasic.point, ByVal pComarca As String, _
    ByVal pConvocatoria As Integer, ByVal pVotants As Long) As Boolean
        Dim vConn As vPClient.Connection
        Dim vGFuncions As New GeneralFuncions
        Dim vGraficPipe As vPClient.OriginatingPipe
        Dim vRS As GDO.GRecordset
        Dim GSS As vPClient.GeometryStorageService
        Dim vObj As Object
        Dim vText As New PBasic.TextPointGeometry
        Dim strEti As String, vNameComarca As String
        Dim vCorrectGrafic As Boolean = True
        '=========================================================
        On Error GoTo Error_Build_TextsOfArcGrafic
        'Construm el rectangle gran
        vConn = gobjGeoApp.Document.Connections(1)
        GSS = gobjGeoApp.CreateService("GeoMedia.GeometryStorageService")
        vText = gobjGeoApp.CreateService("Geomedia.TextPointGeometry")
        vConn.CreateOriginatingPipe(vGraficPipe)
        '=============================================================
        'Afegir un rtol general i centrat
        '=============================================================
        'Afegir textos pel quadre general: En primer lloc les etiquetes de les linies horitzontals
        vNameComarca = vGFuncions.DLookup("[NOM_COMAR]", "COMARQUES", "D.[COMARCA]='" & pComarca & "'")
        strEti = "Comarca: " & Trim(vNameComarca) & " Eleccions: " & pConvocatoria & " - Votants: " & Format(pVotants, "#,##0.")
        With vText
            .Origin.Y = pOrigen.Y + (ALTURA_TOTAL_GRAFIC * (95 / 100))
            .text = strEti
            .Origin.X = pOrigen.X + (AMPLADA_GRAFIC / 2)
            .Origin.Z = 0.0#
            .Normal.I = 0
            .Normal.J = 0
            .Normal.K = 1
            .Alignment = 0 'gmaCenterCenter
            .Rotation = 0
        End With
        'Arxivem l'objecte a la BD
        GSS.GeometryToStorage(vText, vObj)
        vConn.CreateOriginatingPipe(vGraficPipe)
        With vGraficPipe
            .Table = "RetolGraficSectors"
            .GeometryFieldName = "Geometry"
            .Filter = "COMARCA='" & pComarca & "' AND CONVOCATORIA=" & pConvocatoria
        End With
        vRS = vGraficPipe.OutputRecordset
        If Not vRS.BOF And Not vRS.EOF Then
            vRS.MoveLast() : vRS.MoveFirst()
            With vRS
                .Edit()
                .GFields("Geometry").Value = vObj
                .Update()
            End With
        Else
            With vRS
                .AddNew()
                .GFields("COMARCA").Value = pComarca
                .GFields("CONVOCATORIA").Value = pConvocatoria
                .GFields("Geometry").Value = vObj
                .Update()
            End With
        End If
        '==================================================
        'Collocar les entitats al mapview
        '==================================================
        Dim MV As Intergraph.GeoMedia.MapviewLib.GMMapView
        Dim objRLE As PView.LegendEntry
        Dim objPropertyTitle As New vPClient.GMProperty
        Dim objStyleService As PView.StyleService
        Dim objstyle As PView.StyleDefinition
        Dim objFrameStyle As PView.StyleDefinition 'Pel marc dels text definim un area style amb el
        Dim objstyleB As PView.StyleDefinition ' Boundary style i el 
        Dim objstyleF As PView.StyleDefinition ' Fill color
        MV = gobjGeoApp.ActiveWindow.Mapview
        objStyleService = gobjGeoApp.CreateService("GeoMedia.StyleService")
        '======================================================================================
        'Create frame style for bounding text
        objStyleService.GetStyle("Area Style", objFrameStyle)
        'Specify boundary style
        objstyleB = objFrameStyle.StyleDefinitions(0).StyleDefinitions(0)
        objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 35
        objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 0, 182)
        'Specify fill color
        objstyleF = objFrameStyle.StyleDefinitions(1).StyleDefinitions(0)
        objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(180, 180, 255)
        objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyTranslucency).Value = 35 'Translucidesa
        '======================================================================================
        'Create a text style
        objStyleService.GetStyle("Text Style", objstyle)
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFontName).Value = "Arial"
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 0, 182)
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFontBold).Value = True
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFontSize).Value = 400
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFrameType).Value = PView.StyleFrameTypeConstants.gmgroFrameTypeRectangular
        objstyle.StyleProperties.Add(PView.StylePropertyConstants.gmgroPropertyFrameStyle).Value = objFrameStyle
        '============================================
        ' Comencem amb la inclusi a la llegenda
        '============================================
        objRLE = CreateObject("Geomedia.LegendEntry")
        objPropertyTitle.Name = "Title"
        objPropertyTitle.Value = "Rtol Sectors"
        vGraficPipe.Filter = "COMARCA='" & pComarca & "'"
        With objRLE
            .Name = "Rtol Sectors"
            .GeometryFieldName = "Geometry"
            .InputRecordset = vGraficPipe.OutputRecordset
            .Style = objstyle
            .PropertySet.Append(objPropertyTitle)
        End With
        MV.Legend.LegendEntries.Append(objRLE, 1)
        objRLE.LoadData()
        MV.Fit()
        MV.Legend.Fit()
        ''====================================================

Build_TextsOfArcGrafic_Exit:
        strEti = Nothing
        vGFuncions = Nothing
        vObj = Nothing
        vText = Nothing
        objstyleB = Nothing
        objstyleF = Nothing
        objstyle = Nothing
        objFrameStyle = Nothing
        objPropertyTitle = Nothing
        objStyleService = Nothing
        objRLE = Nothing
        MV = Nothing
        GSS = Nothing
        vGraficPipe = Nothing
        vRS = Nothing
        vConn = Nothing
        Build_TextsOfArcChart = vCorrectGrafic
        Exit Function

Error_Build_TextsOfArcGrafic:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Build Text of Graphic Lines", 64)
        vCorrectGrafic = False
        'Resume Next
        Resume Build_TextsOfArcGrafic_Exit
    End Function

    'Aquest procedimet construeix les etiquetes que es posen per marcar les linies: Per una banda
    '   Els textos per les linies horitzontals. Per altra els textos per les lnies verticals que varien
    '   en funci si es tracten ms o menys convocatries.
    '@param pResultats() = array d'una estructura de dades que cont les dades electorals
    '@param pOrigen = objecte que representa el punt d'origen per construir la geometria
    '@param pComarca = codi de la comarca tractada
    '@param pGrafic = text que indica el tipus de grafic que treballem
    Public Function Build_TextsOfGrafics(ByVal pResultats() As frmCHARTSDATA.ResultatsPartits, ByVal pOrigen As PBasic.point, _
    ByVal pComarca As String, ByVal pGrafic As String) As Boolean
        Dim vConn As vPClient.Connection
        Dim vGraficPipe As vPClient.OriginatingPipe
        Dim vRS As GDO.GRecordset
        Dim GSS As vPClient.GeometryStorageService
        Dim vObj As Object
        Dim vText As New PBasic.TextPointGeometry
        Dim vX As Double, vY As Double, vZ As Double, i As Integer, j As Integer
        Dim strEti As String, strDatos As String
        Dim vLabel As LabelGraphic()
        Dim vCorrectGrafic As Boolean = True
        Dim vNameComarca As String, vGFuncions = New GeneralFuncions
        '=========================================================
        On Error GoTo Error_Build_TextsOfGrafics
        'Construm el rectangle gran
        vX = pOrigen.X : vY = pOrigen.Y : vZ = pOrigen.Z
        vConn = gobjGeoApp.Document.Connections(1)
        GSS = gobjGeoApp.CreateService("GeoMedia.GeometryStorageService")
        vText = gobjGeoApp.CreateService("Geomedia.TextPointGeometry")
        vConn.CreateOriginatingPipe(vGraficPipe)
        '=============================================================
        'Afegir un rtol general i centrat
        '=============================================================
        vNameComarca = vGFuncions.DLookup("[NOM_COMAR]", "COMARQUES", "D.[COMARCA]='" & pComarca & "'")
        strEti = "GraC" 'De general Comarca
        For i = 0 To UBound(pResultats) - 1
            Select Case i
                Case 0
                    strDatos = "Any " & Str(pResultats(i).Anyo) & " Cens: " & Format(pResultats(i).Cens, "#,#00.") & " Votants: " & Format(pResultats(i).Votans, "#,#00.") & "; "
                Case 1
                    strDatos = strDatos & "Any " & Str(pResultats(i).Anyo) & " Cens: " & Format(pResultats(i).Cens, "#,#00.") & " Votants: " & Format(pResultats(i).Votans, "#,#00.")
            End Select
        Next
        With vText
            .Origin.X = pOrigen.X + (AMPLADA_GRAFIC / 2)
            If pGrafic = frmCHARTSDATA.GRAFIC_LINIES Then
                .Origin.Y = pOrigen.Y + (ALTURA_TOTAL_GRAFIC * (88 / 100))
            Else
                .Origin.Y = pOrigen.Y + (ALTURA_DATOS_EN_GRAFIC * (95 / 100))
            End If
            .Origin.Z = 0.0#
            .text = "Comarca: " & Trim(vNameComarca)
            .Normal.I = 0
            .Normal.J = 0
            .Normal.K = 1
            .Alignment = 0 'gmaCenterCenter
            .Rotation = 0
        End With
        ' Arxivem l'objecte a la BD
        GSS.GeometryToStorage(vText, vObj)
        With vGraficPipe
            .Table = "RetolsLinies"
            .GeometryFieldName = "Geometry"
            .Filter = "COMARCA='" & pComarca & "' AND ETI='" & strEti & "'"
        End With
        vRS = vGraficPipe.OutputRecordset
        If Not vRS.BOF And Not vRS.EOF Then
            vRS.MoveLast() : vRS.MoveFirst()
            With vRS
                .Edit()
                .GFields("Geometry").Value = vObj
                .Update()
            End With
        Else
            With vRS
                .AddNew()
                .GFields("COMARCA").Value = pComarca
                .GFields("ETI").Value = strEti
                .GFields("DATOS").Value = strDatos
                .GFields("Geometry").Value = vObj
                .Update()
            End With
        End If
        '=============================================================
        'Afegir textos pel quadre general: En primer lloc les etiquetes de les linies horitzontals
        For i = 0 To 80 Step 20
            strEti = Trim(Str(i)) & "%"
            With vText
                .Origin.X = pOrigen.X + 500
                If pGrafic = frmCHARTSDATA.GRAFIC_LINIES Then
                    .Origin.Y = pOrigen.Y + (ALTURA_DATOS_EN_GRAFIC * (i / 100)) + 5000
                    '.Origin.Y = pOrigen.Y + (ALTURA_DATOS_EN_GRAFIC * (i / 100)) + 10000
                Else
                    .Origin.Y = pOrigen.Y + (ALTURA_DATOS_EN_GRAFIC * (i / 100))
                End If
                .Origin.Z = 0.0#
                .Normal.I = 0
                .Normal.J = 0
                .Normal.K = 1
                .Alignment = 1 'gmaCenterLeft 9 = BottomLeft
                .Rotation = 0
                .text = strEti
            End With
            ' Arxivem l'objecte a la BD
            GSS.GeometryToStorage(vText, vObj)
            With vGraficPipe
                .Table = "RetolsLinies"
                .GeometryFieldName = "Geometry"
                .Filter = "COMARCA='" & pComarca & "' AND ETI='" & strEti & "'"
            End With
            vRS = vGraficPipe.OutputRecordset
            If Not vRS.BOF And Not vRS.EOF Then
                vRS.MoveLast() : vRS.MoveFirst()
                With vRS
                    .Edit()
                    .GFields("Geometry").Value = vObj
                    .Update()
                End With
            Else
                With vRS
                    .AddNew()
                    .GFields("COMARCA").Value = pComarca
                    .GFields("ETI").Value = strEti
                    .GFields("Geometry").Value = vObj
                    .Update()
                End With
            End If
        Next i
        'Afegir textos pel quadre general: Desprs les etiquetes de les linies verticals
        If pGrafic = frmCHARTSDATA.GRAFIC_LINIES Then
            Select Case UBound(pResultats)
                Case 2
                    ReDim vLabel(2)
                    j = 0
                    For i = 0 To 1
                        j = j + 2
                        vLabel(i).vX = pOrigen.X + (AMPLADA_GRAFIC * (j / 6))
                        vLabel(i).vStr = Trim(Str(pResultats(i).Anyo))
                        vLabel(i).vStrGran = "Any: " & Trim(Str(pResultats(i).Anyo)) & ". Cens: " & Format(pResultats(i).Cens, "#,#00.") & ". Votants: " & Format(pResultats(i).Votans, "#,#00.")
                    Next
                Case 3
                    ReDim vLabel(3)
                    j = 0
                    For i = 0 To 2
                        j = j + 25
                        vLabel(i).vX = pOrigen.X + (AMPLADA_GRAFIC * (j / 100))
                        vLabel(i).vStr = Trim(Str(pResultats(i).Anyo))
                        vLabel(i).vStrGran = "Any: " & Trim(Str(pResultats(i).Anyo)) & ". Cens: " & Format(pResultats(i).Cens, "#,#00.") & ". Votants: " & Format(pResultats(i).Votans, "#,#00.")
                    Next
                Case 4
                    ReDim vLabel(4)
                    j = 0
                    For i = 0 To 3
                        j = j + 20
                        vLabel(i).vX = pOrigen.X + (AMPLADA_GRAFIC * (j / 100))
                        vLabel(i).vStr = Trim(Str(pResultats(i).Anyo))
                        vLabel(i).vStrGran = "Any: " & Trim(Str(pResultats(i).Anyo)) & ". Cens: " & Format(pResultats(i).Cens, "#,#00.") & ". Votants: " & Format(pResultats(i).Votans, "#,#00.")
                    Next
            End Select
            For i = 0 To UBound(vLabel) - 1
                With vText
                    .Origin.X = vLabel(i).vX
                    .Origin.Y = pOrigen.Y - 3200 + ALTURA_TOTAL_GRAFIC
                    .Origin.Z = 0.0#
                    .Normal.I = 0
                    .Normal.J = 0
                    .Normal.K = 1
                    .Alignment = 8 'gmaBottomCenter, 9 = BottomLeft
                    .Rotation = 0
                    .text = vLabel(i).vStr
                End With
                ' Arxivem l'objecte a la BD
                GSS.GeometryToStorage(vText, vObj)
                With vGraficPipe
                    .Table = "RetolsLinies"
                    .GeometryFieldName = "Geometry"
                    .Filter = "COMARCA='" & pComarca & "' AND ETI='" & vLabel(i).vStr & "'"
                End With
                vRS = vGraficPipe.OutputRecordset
                If Not vRS.BOF And Not vRS.EOF Then
                    vRS.MoveLast() : vRS.MoveFirst()
                    With vRS
                        .Edit()
                        .GFields("Geometry").Value = vObj
                        .Update()
                    End With
                Else
                    With vRS
                        .AddNew()
                        .GFields("COMARCA").Value = pComarca
                        .GFields("ETI").Value = vLabel(i).vStr
                        .GFields("DATOS").Value = vLabel(i).vStrGran
                        .GFields("Geometry").Value = vObj
                        .Update()
                    End With
                End If
            Next i
        End If
        '==================================================
        'Collocar les entitats al mapview
        '==================================================
        Dim MV As Intergraph.GeoMedia.MapviewLib.GMMapView
        Dim objRLE As PView.LegendEntry
        Dim objPropertyTitle As New vPClient.GMProperty
        Dim objStyleService As PView.StyleService
        Dim objstyle As PView.StyleDefinition
        Dim objFrameStyle As PView.StyleDefinition 'Pel marc dels text definim un area style amb el
        Dim objstyleB As PView.StyleDefinition ' Boundary style i el 
        Dim objstyleF As PView.StyleDefinition ' Fill color
        MV = gobjGeoApp.ActiveWindow.Mapview
        objStyleService = gobjGeoApp.CreateService("GeoMedia.StyleService")
        '======================================================================================
        'Create frame style for bounding text
        objStyleService.GetStyle("Area Style", objFrameStyle)
        'Specify boundary style
        objstyleB = objFrameStyle.StyleDefinitions(0).StyleDefinitions(0)
        objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 35
        objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 0, 182)
        'Specify fill color
        objstyleF = objFrameStyle.StyleDefinitions(1).StyleDefinitions(0)
        objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(180, 180, 255)
        objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyTranslucency).Value = 35 'Translucidesa
        '======================================================================================
        'Create a text style
        objStyleService.GetStyle("Text Style", objstyle)
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFontName).Value = "Arial"
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 0, 182)
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFontBold).Value = True
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFontSize).Value = 400
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFrameType).Value = PView.StyleFrameTypeConstants.gmgroFrameTypeRectangular
        objstyle.StyleProperties.Add(PView.StylePropertyConstants.gmgroPropertyFrameStyle).Value = objFrameStyle
        '============================================
        ' Comencem amb la inclusi a la llegenda
        '============================================
        objRLE = CreateObject("Geomedia.LegendEntry")
        objPropertyTitle.Name = "Title"
        objPropertyTitle.Value = "Rtols Linies"
        vGraficPipe.Filter = "COMARCA='" & pComarca & "'"
        With objRLE
            .Name = "Rtols Linies"
            .GeometryFieldName = "Geometry"
            .InputRecordset = vGraficPipe.OutputRecordset
            .Style = objstyle
            .PropertySet.Append(objPropertyTitle)
        End With
        MV.Legend.LegendEntries.Append(objRLE, 1)
        objRLE.LoadData()
        MV.Fit()
        MV.Legend.Fit()
        ''====================================================

Build_TextsOfGrafics_Exit:
        vX = Nothing : vY = Nothing : vZ = Nothing : i = Nothing : j = Nothing
        strEti = Nothing
        strDatos = Nothing
        vLabel = Nothing
        vObj = Nothing
        vText = Nothing
        vNameComarca = Nothing
        vGFuncions = Nothing
        objstyleB = Nothing
        objstyleF = Nothing
        objstyle = Nothing
        objFrameStyle = Nothing
        objPropertyTitle = Nothing
        objStyleService = Nothing
        objRLE = Nothing
        MV = Nothing
        GSS = Nothing
        vGraficPipe = Nothing
        vRS = Nothing
        vConn = Nothing
        Build_TextsOfGrafics = vCorrectGrafic
        Exit Function

Error_Build_TextsOfGrafics:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Build Text of Graphic Lines", 64)
        vCorrectGrafic = False
        'Resume Next
        Resume Build_TextsOfGrafics_Exit
    End Function

    'Aquest procedimet construeix les etiquetes que es posen per identificar els partits
    '@param pPartit = nom del partit del que fer la etiqueta
    '@param pOrigen = objecte que representa el punt d'origen per construir la geometria
    '@param pComarca = codi de la comarca tractada
    '@param pGrafic = textPointGeometry per identificar el partit
    Public Function Build_TextsOfParties(ByVal pPartit As Long, ByVal pOrigen As PBasic.point, _
    ByVal pComarca As String, ByVal pGrafic As String) As Boolean
        Dim vConn As vPClient.Connection
        Dim vGraficPipe As vPClient.OriginatingPipe
        Dim vRS As GDO.GRecordset
        Dim GSS As vPClient.GeometryStorageService
        Dim vObj As Object
        Dim vText As New PBasic.TextPointGeometry
        Dim vX As Double, vY As Double, vZ As Double, i As Integer, j As Integer
        Dim strEti As String
        Dim vCorrectGrafic As Boolean = True
        '=========================================================
        Dim MV As Intergraph.Geomedia.MapviewLib.GMMapView
        Dim objRLE As PView.LegendEntry
        Dim objPropertyTitle As New vPClient.GMProperty
        Dim objStyleService As PView.StyleService
        Dim objstyle As PView.StyleDefinition
        Dim objFrameStyle As PView.StyleDefinition 'Pel marc dels text definim un area style amb el
        Dim objstyleB As PView.StyleDefinition ' Boundary style i el 
        Dim objstyleF As PView.StyleDefinition ' Fill color
        '=========================================================
        On Error GoTo Error_Build_TextsOfParties
        'Construm el rectangle gran
        vConn = gobjGeoApp.Document.Connections(1)
        GSS = gobjGeoApp.CreateService("GeoMedia.GeometryStorageService")
        vText = gobjGeoApp.CreateService("Geomedia.TextPointGeometry")
        'Afegir textos pel quadre general: En primer lloc les etiquetes de les linies horitzontals
        vConn.CreateOriginatingPipe(vGraficPipe)
        '==================================================
        MV = gobjGeoApp.ActiveWindow.Mapview
        objStyleService = gobjGeoApp.CreateService("GeoMedia.StyleService")
        '======================================================================================
        'Create frame style for bounding text
        objStyleService.GetStyle("Area Style", objFrameStyle)
        'Specify boundary style
        objstyleB = objFrameStyle.StyleDefinitions(0).StyleDefinitions(0)
        objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 35
        'Specify fill color
        objstyleF = objFrameStyle.StyleDefinitions(1).StyleDefinitions(0)
        objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyTranslucency).Value = 35 'Translucidesa
        '======================================================================================
        'Create a text style
        objStyleService.GetStyle("Text Style", objstyle)
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFontName).Value = "Arial"
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFontBold).Value = True
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFontSize).Value = 400
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFrameType).Value = PView.StyleFrameTypeConstants.gmgroFrameTypeRectangular
        objstyle.StyleProperties.Add(PView.StylePropertyConstants.gmgroPropertyFrameStyle).Value = objFrameStyle
        Select Case UCase(pPartit)
            Case 1 '"PP"
                vX = pOrigen.X + (AMPLADA_GRAFIC * (1 / 7))
                strEti = "PP"
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 220, 220) 'For a Boundary Style
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 220, 220) 'For a Fill Style
                objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 255, 255) 'For a Text Style
            Case 2 '"CIU"
                vX = pOrigen.X + (AMPLADA_GRAFIC * (2 / 7))
                strEti = "CIU"
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(70, 70, 255) 'For a Boundary Style
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(70, 70, 255) 'For a Fill Style
                objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 255, 255) 'For a Text Style
            Case 3 '"ALTRES"
                vX = pOrigen.X + (AMPLADA_GRAFIC * (3 / 7))
                strEti = "ALTRES"
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(173, 123, 16) 'For a Boundary Style
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(173, 123, 16) 'For a Fill Style
                objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 255, 255) 'For a Text Style
            Case 4 '"PSC"
                vX = pOrigen.X + (AMPLADA_GRAFIC * (4 / 7))
                strEti = "PSC"
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 0, 0) 'For a Boundary Style
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 0, 0) 'For a Fill Style
                objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 255, 255) 'For a Text Style
            Case 5 '"ERC"
                vX = pOrigen.X + (AMPLADA_GRAFIC * (5 / 7))
                strEti = "ERC"
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(249, 244, 0) 'For a Boundary Style
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(249, 244, 0) 'For a Fill Style
                objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 0, 0) 'For a Text Style
            Case 6 '"IC_V"
                vX = pOrigen.X + (AMPLADA_GRAFIC * (6 / 7))
                strEti = "IC_V"
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 182, 0) 'For a Boundary Style
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 182, 0) 'For a Fill Style
                objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 255, 255) 'For a Text Style
        End Select
        'Per tots els casos la Y val -3000
        vY = pOrigen.Y - 3000
        With vText
            .Origin.X = vX
            .Origin.Y = vY
            .Origin.Z = 0.0#
            .Normal.I = 0
            .Normal.J = 0
            .Normal.K = 1
            .Alignment = 0 '= gmaCenterCenter, 1 = gmaCenterLeft; 9=BottomLeft
            .Rotation = 0
            .text = strEti
        End With
        ' Arxivem l'objecte a la BD
        GSS.GeometryToStorage(vText, vObj)
        With vGraficPipe
            Select Case pPartit
                Case 1 '"PP"
                    .Table = "RetolPp"
                Case 2 '"CIU"
                    .Table = "RetolCiu"
                Case 3 '"ALTRES"
                    .Table = "RetolAltres"
                Case 4 '"PSC"
                    .Table = "RetolPsc"
                Case 5 '"ERC"
                    .Table = "RetolErc"
                Case 6 '"IC_V"
                    .Table = "RetolIcv"
            End Select
            .GeometryFieldName = "Geometry"
            .Filter = "COMARCA='" & pComarca & "' AND GRAFIC='" & pGrafic & "' AND TIPUS=1"
        End With
        vRS = vGraficPipe.OutputRecordset
        If Not vRS.BOF And Not vRS.EOF Then
            vRS.MoveLast() : vRS.MoveFirst()
            With vRS
                .Edit()
                .GFields("Geometry").Value = vObj
                .Update()
            End With
        Else
            With vRS
                .AddNew()
                .GFields("COMARCA").Value = pComarca
                .GFields("GRAFIC").Value = pGrafic
                .GFields("Geometry").Value = vObj
                .Update()
            End With
        End If
        '==================================================
        ' Collocar les entitats al mapview
        ' Comencem amb la inclusi a la llegenda
        '==================================================
        objRLE = CreateObject("Geomedia.LegendEntry")
        objPropertyTitle.Name = "Title"
        objPropertyTitle.Value = "PARTIT: " & strEti
        With objRLE
            .Name = "PARTIT: " & strEti
            .GeometryFieldName = "Geometry"
            .InputRecordset = vGraficPipe.OutputRecordset
            .Style = objstyle
            .PropertySet.Append(objPropertyTitle)
        End With
        MV.Legend.LegendEntries.Append(objRLE, 1)
        objRLE.LoadData()
        MV.Fit()
        MV.Legend.Fit()
        '==================================================

Build_TextsOfParties_Exit:
        vX = Nothing : vY = Nothing : vZ = Nothing : i = Nothing : j = Nothing
        strEti = Nothing
        vObj = Nothing
        vText = Nothing
        GSS = Nothing
        vGraficPipe = Nothing
        vRS = Nothing
        vConn = Nothing
        Build_TextsOfParties = vCorrectGrafic
        Exit Function

Error_Build_TextsOfParties:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Build TextOfparties", 64)
        vCorrectGrafic = False
        'Resume Next
        Resume Build_TextsOfParties_Exit
    End Function

    'Aquest procedimet construeix les etiquetes que es posen per identificar els partits.
    'La versi 2 posa les etiquetes a sota del grafic, per dins el marc del mateix
    '@param pPartit = nom del partit del que fer la etiqueta
    '@param pOrigen = objecte que representa el punt d'origen per construir la geometria
    '@param pComarca = codi de la comarca tractada
    '@param pGrafic = textPointGeometry per identificar el partit
    '@param pXRetolPercent = coordenada X per al retol del percentatge
    '@param pYRetolPercent = coordenada Y per al retol del percentatge
    '@param pPercentatge = Tant per cent per l'etiqueta
    Public Function Build_TextsOfParties2(ByVal pPartit As Long, ByVal pOrigen As PBasic.point, _
    ByVal pComarca As String, ByVal pGrafic As String, ByVal pXRetolPercent As Double, _
    ByVal pYRetolPercent As Double, ByVal pPercentatge As Double) As Boolean
        Dim vConn As vPClient.Connection
        Dim vGraficPipe As vPClient.OriginatingPipe
        Dim vRS As GDO.GRecordset
        Dim GSS As vPClient.GeometryStorageService
        Dim vObj As Object, vObjPercent As Object
        Dim vText As New PBasic.TextPointGeometry
        Dim vTextPercent As New PBasic.TextPointGeometry
        Dim vX As Double, vY As Double, vZ As Double, i As Integer, j As Integer
        Dim strEti As String
        Dim vCorrectGrafic As Boolean = True
        '=========================================================
        Dim MV As Intergraph.GeoMedia.MapviewLib.GMMapView
        Dim objRLE As PView.LegendEntry
        Dim objPropertyTitle As New vPClient.GMProperty
        Dim objStyleService As PView.StyleService
        Dim objstyle As PView.StyleDefinition
        Dim objFrameStyle As PView.StyleDefinition 'Pel marc dels text definim un area style amb el
        Dim objstyleB As PView.StyleDefinition ' Boundary style i el 
        Dim objstyleF As PView.StyleDefinition ' Fill color
        '=========================================================
        On Error GoTo Error_Build_TextsOfParties
        'Construm el rectangle gran
        vConn = gobjGeoApp.Document.Connections(1)
        GSS = gobjGeoApp.CreateService("GeoMedia.GeometryStorageService")
        vText = gobjGeoApp.CreateService("Geomedia.TextPointGeometry")
        vTextPercent = gobjGeoApp.CreateService("Geomedia.TextPointGeometry")
        'Afegir textos pel quadre general: En primer lloc les etiquetes de les linies horitzontals
        vConn.CreateOriginatingPipe(vGraficPipe)
        '==================================================
        MV = gobjGeoApp.ActiveWindow.Mapview
        objStyleService = gobjGeoApp.CreateService("GeoMedia.StyleService")
        '======================================================================================
        'Create frame style for bounding text
        objStyleService.GetStyle("Area Style", objFrameStyle)
        'Specify boundary style
        objstyleB = objFrameStyle.StyleDefinitions(0).StyleDefinitions(0)
        objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 35
        'Specify fill color
        objstyleF = objFrameStyle.StyleDefinitions(1).StyleDefinitions(0)
        objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyTranslucency).Value = 35 'Translucidesa
        '======================================================================================
        'Create a text style
        objStyleService.GetStyle("Text Style", objstyle)
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFontName).Value = "Arial"
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFontBold).Value = True
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFontSize).Value = 400
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFrameType).Value = PView.StyleFrameTypeConstants.gmgroFrameTypeRectangular
        objstyle.StyleProperties.Add(PView.StylePropertyConstants.gmgroPropertyFrameStyle).Value = objFrameStyle
        Select Case UCase(pPartit)
            Case 1 '"PP"
                vX = pOrigen.X + (AMPLADA_GRAFIC * (1 / 7))
                vY = pOrigen.Y - 4000
                strEti = "PP"
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 220, 220) 'For a Boundary Style
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 220, 220) 'For a Fill Style
                objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 255, 255) 'For a Text Style
            Case 2 '"CIU"
                vX = pOrigen.X + (AMPLADA_GRAFIC * (2 / 7))
                vY = pOrigen.Y - 4000
                strEti = "CIU"
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(70, 70, 255) 'For a Boundary Style
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(70, 70, 255) 'For a Fill Style
                objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 255, 255) 'For a Text Style
            Case 3 '"ALTRES"
                vX = pOrigen.X + (AMPLADA_GRAFIC * (3 / 7))
                vY = pOrigen.Y - 4000
                strEti = "ALTRES"
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(173, 123, 16) 'For a Boundary Style
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(173, 123, 16) 'For a Fill Style
                objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 255, 255) 'For a Text Style
            Case 4 '"PSC"
                vX = pOrigen.X + (AMPLADA_GRAFIC * (4 / 7))
                vY = pOrigen.Y - 4000
                strEti = "PSC"
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 0, 0) 'For a Boundary Style
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 0, 0) 'For a Fill Style
                objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 255, 255) 'For a Text Style
            Case 5 '"ERC"
                vX = pOrigen.X + (AMPLADA_GRAFIC * (5 / 7))
                vY = pOrigen.Y - 4000
                strEti = "ERC"
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(249, 244, 0) 'For a Boundary Style
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(249, 244, 0) 'For a Fill Style
                objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 0, 0) 'For a Text Style
            Case 6 '"IC_V"
                vX = pOrigen.X + (AMPLADA_GRAFIC * (6 / 7))
                vY = pOrigen.Y - 4000
                strEti = "IC_V"
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 182, 0) 'For a Boundary Style
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 182, 0) 'For a Fill Style
                objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 255, 255) 'For a Text Style
        End Select
        With vText
            .Origin.X = vX
            .Origin.Y = pOrigen.Y - 3000
            .Origin.Z = 0.0#
            .Normal.I = 0
            .Normal.J = 0
            .Normal.K = 1
            .Alignment = 0 '= gmaCenterCenter, 1 = gmaCenterLeft; 9=BottomLeft
            .Rotation = 0
            .text = strEti
        End With
        With vTextPercent
            .Origin.X = pXRetolPercent
            .Origin.Y = pYRetolPercent
            .Origin.Z = 0.0#
            .Normal.I = 0
            .Normal.J = 0
            .Normal.K = 1
            .Alignment = 0 '= gmaCenterCenter, 1 = gmaCenterLeft; 9=BottomLeft
            .Rotation = 0
            .text = Format(pPercentatge, "Percent")
        End With
        ' Arxivem l'objecte a la BD
        GSS.GeometryToStorage(vText, vObj)
        GSS.GeometryToStorage(vTextPercent, vObjPercent)
        With vGraficPipe
            Select Case pPartit
                Case 1 '"PP"
                    .Table = "RetolPp"
                Case 2 '"CIU"
                    .Table = "RetolCiu"
                Case 3 '"ALTRES"
                    .Table = "RetolAltres"
                Case 4 '"PSC"
                    .Table = "RetolPsc"
                Case 5 '"ERC"
                    .Table = "RetolErc"
                Case 6 '"IC_V"
                    .Table = "RetolIcv"
            End Select
            .GeometryFieldName = "Geometry"
            .Filter = "COMARCA='" & pComarca & "' AND GRAFIC='" & pGrafic & "' AND TIPUS=1"
        End With
        vRS = vGraficPipe.OutputRecordset
        If Not vRS.BOF And Not vRS.EOF Then
            vRS.MoveLast() : vRS.MoveFirst()
            With vRS
                .Edit()
                .GFields("Geometry").Value = vObj
                .Update()
            End With
        Else
            With vRS
                .AddNew()
                .GFields("COMARCA").Value = pComarca
                .GFields("GRAFIC").Value = pGrafic
                .GFields("GRAFIC").Value = 1
                .GFields("Geometry").Value = vObj
                .Update()
            End With
        End If
        With vGraficPipe
            .Filter = "COMARCA='" & pComarca & "' AND GRAFIC='" & pGrafic & "' AND TIPUS=2"
        End With
        vRS = vGraficPipe.OutputRecordset
        If Not vRS.BOF And Not vRS.EOF Then
            vRS.MoveLast() : vRS.MoveFirst()
            With vRS
                .Edit()
                .GFields("Geometry").Value = vObjPercent
                .Update()
            End With
        Else
            With vRS
                .AddNew()
                .GFields("COMARCA").Value = pComarca
                .GFields("GRAFIC").Value = pGrafic
                .GFields("TIPUS").Value = 2
                .GFields("Geometry").Value = vObjPercent
                .Update()
            End With
        End If
        '==================================================
        ' Collocar les entitats al mapview
        ' Comencem amb la inclusi a la llegenda
        '==================================================
        objRLE = CreateObject("Geomedia.LegendEntry")
        objPropertyTitle.Name = "Title"
        objPropertyTitle.Value = "PARTIT: " & strEti
        With objRLE
            .Name = "PARTIT: " & strEti
            .GeometryFieldName = "Geometry"
            .InputRecordset = vGraficPipe.OutputRecordset
            .Style = objstyle
            .PropertySet.Append(objPropertyTitle)
        End With
        MV.Legend.LegendEntries.Append(objRLE, 1)
        objRLE.LoadData()
        MV.Fit()
        MV.Legend.Fit()
        '==================================================

Build_TextsOfParties_Exit:
        vX = Nothing : vY = Nothing : vZ = Nothing : i = Nothing : j = Nothing
        strEti = Nothing
        vObj = Nothing : vObjPercent = Nothing
        vText = Nothing
        GSS = Nothing
        vGraficPipe = Nothing
        vRS = Nothing
        vConn = Nothing
        Build_TextsOfParties2 = vCorrectGrafic
        Exit Function

Error_Build_TextsOfParties:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Build TextOfparties2", 64)
        vCorrectGrafic = False
        'Resume Next
        Resume Build_TextsOfParties_Exit
    End Function

    'Aquest procedimet construeix el quadre grafic de linies i les linies. Si hi ha error ho torna
    '@param pComarca = Codi de la comarca de la que es construeix la geometria
    '@param pOrigen = objecte que representa el punt d'origen per construir la geometria
    '@param pConvocatories = nombre de convocatories a tractar
    Public Function Build_ArcChart(ByVal pComarca As String, ByVal pOrigen As PBasic.point, _
    ByVal pConvocatoria As Integer)
        Dim vConn As vPClient.Connection
        Dim vGraficPipe As vPClient.OriginatingPipe
        Dim vRS As GDO.GRecordset, vRS2 As GDO.GRecordset
        Dim GSS As vPClient.GeometryStorageService
        '=========================================
        Dim vPoligon As New PBasic.PolygonGeometry ' Pel polgon inicial
        '=========================================
        Dim vObj As Object
        Dim vPunt As New PBasic.point
        Dim vX As Double, vY As Double, vZ As Double, i As Integer, j As Integer
        Dim vCorrectGrafic As Boolean = True, vNameComarca As String, vGFuncions = New GeneralFuncions
        '=========================================================
        On Error GoTo Error_Build_ArcChart
        'Construm el rectangle gran
        vX = pOrigen.X : vY = pOrigen.Y : vZ = pOrigen.Z
        vConn = gobjGeoApp.Document.Connections(1)
        GSS = gobjGeoApp.CreateService("GeoMedia.GeometryStorageService")
        vPunt = gobjGeoApp.CreateService("GeoMedia.Point")
        '=========================================================
        vPoligon = gobjGeoApp.CreateService("GeoMedia.PolygonGeometry")
        'Per al polgon
        '===============================================
        vPunt.Y = vPunt.Y - 10000
        For i = 1 To 5 ' Sn cinc punts ja que el primer i l'ultim coincideixen
            vPunt.X = pOrigen.X : vPunt.Y = pOrigen.Y : vPunt.Z = pOrigen.Z
            Select Case i 'Per als punts 1 i 5 es pren l'origen
                Case 2
                    vPunt.Y = pOrigen.Y + ALTURA_TOTAL_GRAFIC
                Case 3
                    vPunt.X = vPunt.X + AMPLADA_GRAFIC : vPunt.Y = vPunt.Y + ALTURA_TOTAL_GRAFIC
                Case 4
                    vPunt.X = pOrigen.X + AMPLADA_GRAFIC
            End Select
            vPoligon.Points.Add(vPunt)
        Next
        'Arxivem l'objecte a la BD
        GSS.GeometryToStorage(vPoligon, vObj)
        vConn.CreateOriginatingPipe(vGraficPipe)
        With vGraficPipe
            .Table = "GraficSectors"
            .GeometryFieldName = "Geometry"
            .Filter = "COMARCA='" & pComarca & "' AND CONVOCATORIA=" & pConvocatoria
        End With
        vRS = vGraficPipe.OutputRecordset
        If Not vRS.BOF And Not vRS.EOF Then
            vRS.MoveLast() : vRS.MoveFirst()
            With vRS
                .Edit()
                .GFields("Geometry").Value = vObj
                .Update()
            End With
        Else
            With vRS
                .AddNew()
                .GFields("COMARCA").Value = pComarca
                .GFields("CONVOCATORIA").Value = pConvocatoria
                .GFields("Geometry").Value = vObj
                .Update()
            End With
        End If
        '==================================================
        'Collocar les entitats al mapview
        '==================================================
        Dim MV As Intergraph.GeoMedia.MapviewLib.GMMapView
        Dim objRLE As PView.LegendEntry
        Dim objPropertyTitle As New vPClient.GMProperty
        Dim objStyleService As New PView.StyleService
        Dim objstyle As PView.StyleDefinition = Nothing ' pel l'rea
        Dim objstyleB As PView.StyleDefinition ' Boundary style
        Dim objstyleF As PView.StyleDefinition ' Specify fill color
        MV = gobjGeoApp.ActiveWindow.Mapview
        objStyleService.GetStyle("Area Style", objstyle)
        'Specify boundary style
        objstyleB = objstyle.StyleDefinitions(0).StyleDefinitions(0)
        objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 35
        objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 0, 182)
        'Specify fill color
        objstyleF = objstyle.StyleDefinitions(1).StyleDefinitions(0)
        objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(185, 231, 198)
        objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyTranslucency).Value = 35 'Translucidesa
        '============================================
        ' Comencem amb la inclusi a la llegenda
        '============================================
        vNameComarca = vGFuncions.DLookup("[NOM_COMAR]", "COMARQUES", "D.[COMARCA]='" & pComarca & "'")
        objRLE = CreateObject("Geomedia.LegendEntry")
        objPropertyTitle.Name = "Title"
        objPropertyTitle.Value = "Grfic " & Trim(vNameComarca)
        With objRLE
            .Name = Trim(vNameComarca)
            .GeometryFieldName = "Geometry"
            .InputRecordset = vGraficPipe.OutputRecordset
            .Style = objstyle
            .PropertySet.Append(objPropertyTitle)
        End With
        MV.Legend.LegendEntries.Append(objRLE, 1)
        objRLE.LoadData()
        MV.Fit()
        MV.Legend.Fit()
        '====================================================

Build_ArcChart_Exit:
        vX = Nothing : vY = Nothing : vZ = Nothing : vNameComarca = Nothing
        vObj = Nothing : vGFuncions = Nothing
        vPunt = Nothing
        vPoligon = Nothing
        '====================== Estils: prefixe s
        objstyleB = Nothing
        objstyleF = Nothing
        objstyle = Nothing
        '===================== Carpetes d'estil: prefixe f
        objPropertyTitle = Nothing
        objStyleService = Nothing
        objRLE = Nothing
        MV = Nothing
        '====================== Objectes de dades
        GSS = Nothing
        vGraficPipe = Nothing
        vRS = Nothing : vRS2 = Nothing
        vConn = Nothing
        Build_ArcChart = vCorrectGrafic
        Exit Function

Error_Build_ArcChart:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Build ArcChart", 64)
        vCorrectGrafic = False
        'Resume Next
        Resume Build_ArcChart_Exit
    End Function


    'Aquest procedimet construeix el quadre grafic de linies i les linies. Si hi ha error ho torna
    '@param pComarca = Codi de la comarca de la que es construeix la geometria
    '@param pOrigen = objecte que representa el punt d'origen per construir la geometria
    '@param pResultats = estructura amb les dades del resultat
    '@param pPreviusAngle = angle previ per calcular el nou acumulat
    '@param pX = coordenada X previa. Quan surt agafa el valor de la nova coordenada
    '@param PY = coordenada Y previa. quan surt agafa el valor de la nova coordenada
    Public Function Build_ArcOfParties(ByVal pComarca As String, ByVal pResultats As frmCHARTSDATA.ResultatsPartits, _
         ByVal pOrigen As PBasic.point, ByVal pXPreGran As Double, ByVal pYPreGran As Double, ByVal pXPostGran As Double, ByVal pYPostGran As Double, _
         ByVal pXPrePetit As Double, ByVal pYPrePetit As Double, ByVal pXPostPetit As Double, ByVal pYPostPetit As Double)
        Dim vGFuncions As New GeneralFuncions
        Dim vConn As vPClient.Connection
        'Dim vGraficPipe As vPClient.OriginatingPipe
        Dim vDB As GDO.GDatabase, strSQL As String
        Dim vRS As GDO.GRecordset, vGraficPipe As vPClient.OriginatingPipe
        Dim GSS As vPClient.GeometryStorageService
        '=========================================
        Dim objArc1 As New PBasic.ArcGeometry, objArc2 As New PBasic.ArcGeometry
        Dim vLinia1 As New PBasic.LineGeometry 'Per la linia de l'esquerra
        Dim vLinia2 As New PBasic.LineGeometry 'Per la linia de la dreta
        '=========================================
        Dim vObj As Object
        Dim vPunt As New PBasic.point
        Dim vSector As New PBasic.CompositePolygonGeometry
        'Dim vColeccio As New PBasic.GeometryCollection
        Dim vCorrectGrafic As Boolean = True, vNameComarca As String
        Dim vPartit As String
        '=========================================================
        On Error GoTo Error_Build_ArcOfParties
        vConn = gobjGeoApp.Document.Connections(1)
        GSS = gobjGeoApp.CreateService("GeoMedia.GeometryStorageService")
        vPunt = gobjGeoApp.CreateService("GeoMedia.Point")
        '=========================================================
        vLinia1 = gobjGeoApp.CreateService("GeoMedia.LineGeometry")
        vLinia2 = gobjGeoApp.CreateService("GeoMedia.LineGeometry")
        objArc1 = gobjGeoApp.CreateService("GeoMedia.ArcGeometry")
        objArc2 = gobjGeoApp.CreateService("GeoMedia.ArcGeometry")
        'vColeccio = gobjGeoApp.CreateService("GeoMedia.GeometryCollection")
        vSector = gobjGeoApp.CreateService("GeoMedia.CompositePolygonGeometry")
        'Construm les linies del sector: Primera linia
        vLinia1.Start.X = pXPreGran 'pXPrePetit 'pOrigen.X
        vLinia1.Start.Y = pYPreGran 'pYPrePetit 'pOrigen.Y
        vLinia1.Start.Z = 0.0#
        vLinia1.End.X = pXPrePetit 'pXPreGran
        vLinia1.End.Y = pYPrePetit 'pYPreGran
        vLinia1.End.Z = 0.0#
        'Segona Linia
        vLinia2.Start.X = pXPostPetit 'pOrigen.X
        vLinia2.Start.Y = pYPostPetit 'pOrigen.Y
        vLinia2.Start.Z = 0.0#
        vLinia2.End.X = pXPostGran
        vLinia2.End.Y = pYPostGran
        vLinia2.End.Z = 0.0#
        vSector.Add(vLinia2)
        'Per construir el primer Arc
        With objArc1
            .Origin.X = pOrigen.X : .Origin.Y = pOrigen.Y : .Origin.Z = 0.0#
            .Start.X = pXPostGran : .Start.Y = pYPostGran : .Start.Z = 0.0#
            .End.X = pXPreGran : .End.Y = pYPreGran : .End.Z = 0.0#
            .Radius = modCHARTSDATA.RADI_SECTOR
            .Normal.I = 0
            .Normal.J = 0
            .Normal.K = 1
            .GreaterThanPi = False
        End With
        vSector.Add(objArc1)
        vSector.Add(vLinia1)
        'Per construir el segon Arc
        With objArc2
            .Origin.X = pOrigen.X : .Origin.Y = pOrigen.Y : .Origin.Z = 0.0#
            .Start.X = pXPostPetit : .Start.Y = pYPostPetit : .Start.Z = 0.0#
            .End.X = pXPrePetit : .End.Y = pYPrePetit : .End.Z = 0.0#
            .Radius = modCHARTSDATA.RADI_SECTOR_PETIT
            .Normal.I = 0
            .Normal.J = 0
            .Normal.K = 1
            .GreaterThanPi = False
        End With
        vSector.Add(objArc2)
        'Arxivem l'objecte a la BD
        '=============================================================
        'GSS.GeometryToStorage(vColeccio, vObj)
        GSS.GeometryToStorage(vSector, vObj)
        vConn.CreateOriginatingPipe(vGraficPipe)
        With vGraficPipe
            Select Case UCase(Trim(pResultats.Partit))
                Case "PP"
                    .Table = "SectorPp"
                Case "CIU"
                    .Table = "SectorCiu"
                Case "ALTRES"
                    .Table = "SectorAltres"
                Case "PSC"
                    .Table = "SectorPsc"
                Case "ERC"
                    .Table = "SectorErc"
                Case "IC_V"
                    .Table = "SectorIc_v"
            End Select
            .GeometryFieldName = "Geometry"
            .Filter = "COMARCA='" & pComarca & "'"
        End With
        vRS = vGraficPipe.OutputRecordset
        If Not vRS.EOF And Not vRS.BOF Then
            vRS.MoveLast() : vRS.MoveFirst()
            With vRS
                .Edit()
                .GFields("NOMBRE_VOTS").Value = Format(pResultats.Vots, "#,##0.")
                .GFields("PERCENTATGE").Value = pResultats.Vots / pResultats.Votans
                .GFields("Geometry").Value = vObj
                .Update()
            End With
        Else
            With vRS
                .AddNew()
                .GFields("COMARCA").Value = pComarca
                .GFields("NOMBRE_VOTS").Value = Format(pResultats.Vots, "#,##0.")
                .GFields("PERCENTATGE").Value = pResultats.Vots / pResultats.Votans
                .GFields("Geometry").Value = vObj
                .Update()
            End With
        End If
        '==================================================
        'Collocar les entitats al mapview
        '==================================================
        Dim MV As Intergraph.GeoMedia.MapviewLib.GMMapView
        Dim objRLE As PView.LegendEntry
        Dim objPropertyTitle As New vPClient.GMProperty
        Dim objStyleService As New PView.StyleService
        Dim objstyle As PView.StyleDefinition = Nothing ' pel l'rea
        Dim objstyleB As PView.StyleDefinition ' Boundary style
        Dim objstyleF As PView.StyleDefinition ' Specify fill color
        MV = gobjGeoApp.ActiveWindow.Mapview
        objStyleService.GetStyle("Area Style", objstyle)
        'Specify boundary style
        objstyleB = objstyle.StyleDefinitions(0).StyleDefinitions(0)
        objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 35
        objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(185, 231, 198) 'For a Boundary Style
        'Specify fill color
        objstyleF = objstyle.StyleDefinitions(1).StyleDefinitions(0)
        objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyTranslucency).Value = 35 'Translucidesa
        Select Case UCase(Trim(pResultats.Partit))
            Case "PP"
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 220, 220) 'For a Fill Style
            Case "CIU"
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(70, 70, 255) 'For a Fill Style
            Case "ALTRES"
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(173, 123, 16) 'For a Fill Style
            Case "PSC"
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 0, 0) 'For a Fill Style
            Case "ERC"
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(249, 244, 0) 'For a Fill Style
            Case "IC_V"
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 182, 0) 'For a Fill Style
        End Select
        '============================================
        ' Comencem amb la inclusi a la llegenda
        '============================================
        objRLE = CreateObject("Geomedia.LegendEntry")
        objPropertyTitle.Name = "Title"
        objPropertyTitle.Value = "Partit: " & UCase(Trim(pResultats.Partit))
        With objRLE
            .Name = UCase(Trim(pResultats.Partit))
            .GeometryFieldName = "Geometry"
            .InputRecordset = vGraficPipe.OutputRecordset
            .Style = objstyle
            .PropertySet.Append(objPropertyTitle)
        End With
        MV.Legend.LegendEntries.Append(objRLE, 1)
        objRLE.LoadData()
        MV.Fit()
        MV.Legend.Fit()
        '====================================================

Build_ArcOfParties_Exit:
        vNameComarca = Nothing
        vObj = Nothing : vGFuncions = Nothing
        vPunt = Nothing
        vLinia1 = Nothing
        vLinia2 = Nothing
        objArc1 = Nothing
        'vColeccio = Nothing
        vSector = Nothing
        '====================== Estils: prefixe s
        'objstyle1 = Nothing
        'objstyle2 = Nothing
        objstyleB = Nothing
        objstyleF = Nothing
        objstyle = Nothing
        ''===================== Carpetes d'estil: prefixe f
        objPropertyTitle = Nothing
        objStyleService = Nothing
        objRLE = Nothing
        MV = Nothing
        '====================== Objectes de dades
        GSS = Nothing
        vRS = Nothing
        vDB = Nothing
        vConn = Nothing
        Build_ArcOfParties = vCorrectGrafic
        Exit Function

Error_Build_ArcOfParties:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Build ArcOfParties", 64)
        vCorrectGrafic = False
        'Resume Next
        Resume Build_ArcOfParties_Exit
    End Function

    'Aquest procedimet construeix el quadre grafic de Barres. Si hi ha error ho torna
    '@param pComarca = Codi de la comarca de la que es construeix la geometria
    '@param pOrigen = objecte que representa el punt d'origen per construir la geometria
    '@param pConvocatories = nombre de convocatories a tractar
    Public Function Build_BarChart(ByVal pComarca As String, ByVal pOrigen As PBasic.point)
        Dim vConn As vPClient.Connection
        Dim vGraficPipe As vPClient.OriginatingPipe
        Dim vRS As GDO.GRecordset, vRS2 As GDO.GRecordset
        Dim GSS As vPClient.GeometryStorageService
        Dim vObj As Object
        Dim vPunt As New PBasic.point
        Dim vLinia00h As New PBasic.LineGeometry 'Per les horitzontals
        Dim vLinia01h As New PBasic.LineGeometry
        Dim vLinia02h As New PBasic.LineGeometry
        Dim vLinia03h As New PBasic.LineGeometry
        Dim vLinia04h As New PBasic.LineGeometry
        Dim vPoligon As New PBasic.PolygonGeometry
        Dim vColeccio As New PBasic.GeometryCollection
        Dim i As Integer
        Dim vCorrectGrafic As Boolean = True, vNameComarca As String, vGFuncions = New GeneralFuncions
        '=========================================================
        On Error GoTo Error_Build_BarChart
        'Construm el rectangle gran
        vConn = gobjGeoApp.Document.Connections(1)
        GSS = gobjGeoApp.CreateService("GeoMedia.GeometryStorageService")
        vPunt = gobjGeoApp.CreateService("GeoMedia.Point")
        vLinia00h = gobjGeoApp.CreateService("GeoMedia.LineGeometry")
        vLinia01h = gobjGeoApp.CreateService("GeoMedia.LineGeometry")
        vLinia02h = gobjGeoApp.CreateService("GeoMedia.LineGeometry")
        vLinia03h = gobjGeoApp.CreateService("GeoMedia.LineGeometry")
        vLinia04h = gobjGeoApp.CreateService("GeoMedia.LineGeometry")
        vPoligon = gobjGeoApp.CreateService("GeoMedia.PolygonGeometry")
        vColeccio = gobjGeoApp.CreateService("GeoMedia.GeometryCollection")
        'Per al primer polgon
        '===============================================
        For i = 1 To 5 ' Sn cinc punts ja que el primer i l'ultim coincideixen
            vPunt.X = pOrigen.X : vPunt.Y = pOrigen.Y : vPunt.Z = pOrigen.Z
            Select Case i 'Per als punts 1 i 5 es pren l'origen
                Case 2
                    vPunt.Y = pOrigen.Y + ALTURA_TOTAL_GRAFIC
                Case 3
                    vPunt.X = vPunt.X + AMPLADA_GRAFIC : vPunt.Y = vPunt.Y + ALTURA_TOTAL_GRAFIC
                Case 4
                    vPunt.X = pOrigen.X + AMPLADA_GRAFIC
            End Select
            vPoligon.Points.Add(vPunt)
        Next
        vColeccio.Add(vPoligon)
        'Construm les linies del rectangle
        'Per les horitzontals:
        vPunt = pOrigen
        For i = 0 To 80 Step 20
            Select Case i
                Case 0
                    vLinia00h.Start.X = vPunt.X : vLinia00h.Start.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia01h.Start.Z = vPunt.Z
                    vLinia00h.End.X = vPunt.X + AMPLADA_GRAFIC : vLinia00h.End.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia01h.End.Z = vPunt.Z
                    vColeccio.Add(vLinia00h)
                Case 20
                    vLinia01h.Start.X = vPunt.X : vLinia01h.Start.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia01h.Start.Z = vPunt.Z
                    vLinia01h.End.X = vPunt.X + AMPLADA_GRAFIC : vLinia01h.End.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia01h.End.Z = vPunt.Z
                    vColeccio.Add(vLinia01h)
                Case 40
                    vLinia02h.Start.X = vPunt.X : vLinia02h.Start.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia02h.Start.Z = vPunt.Z
                    vLinia02h.End.X = vPunt.X + AMPLADA_GRAFIC : vLinia02h.End.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia02h.End.Z = vPunt.Z
                    vColeccio.Add(vLinia02h)
                Case 60
                    vLinia03h.Start.X = vPunt.X : vLinia03h.Start.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia03h.Start.Z = vPunt.Z
                    vLinia03h.End.X = vPunt.X + AMPLADA_GRAFIC : vLinia03h.End.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia03h.End.Z = vPunt.Z
                    vColeccio.Add(vLinia03h)
                Case 80
                    vLinia04h.Start.X = vPunt.X : vLinia04h.Start.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia04h.Start.Z = vPunt.Z
                    vLinia04h.End.X = vPunt.X + AMPLADA_GRAFIC : vLinia04h.End.Y = vPunt.Y + (ALTURA_DATOS_EN_GRAFIC * i / 100) + 5000 : vLinia04h.End.Z = vPunt.Z
                    vColeccio.Add(vLinia04h)
            End Select
        Next
        'Arxivem l'objecte a la BD
        GSS.GeometryToStorage(vColeccio, vObj)
        vConn.CreateOriginatingPipe(vGraficPipe)
        With vGraficPipe
            .Table = "GraficBarres"
            .GeometryFieldName = "Geometry"
            .Filter = "COMARCA='" & pComarca & "'"
        End With
        vRS = vGraficPipe.OutputRecordset
        If Not vRS.BOF And Not vRS.EOF Then
            vRS.MoveLast() : vRS.MoveFirst()
            With vRS
                .Edit()
                .GFields("Geometry").Value = vObj
                .Update()
            End With
        Else
            With vRS
                .AddNew()
                .GFields("COMARCA").Value = pComarca
                .GFields("Geometry").Value = vObj
                .Update()
            End With
        End If
        '==================================================
        'Collocar les entitats al mapview
        '==================================================
        Dim MV As Intergraph.GeoMedia.MapviewLib.GMMapView
        Dim objRLE As PView.LegendEntry
        Dim objPropertyTitle As New vPClient.GMProperty
        Dim objStyleService As New PView.StyleService
        Dim objstyle As PView.StyleDefinition = Nothing ' per al compost
        Dim objstyle1 As PView.StyleDefinition = Nothing ' pel l'rea
        Dim objstyle2 As PView.StyleDefinition = Nothing ' per al liniear
        Dim objstyleB As PView.StyleDefinition ' Boundary style
        Dim objstyleF As PView.StyleDefinition ' Specify fill color
        MV = gobjGeoApp.ActiveWindow.Mapview
        objStyleService.GetStyle("Compound Style", objstyle)
        'objStyleService.GetStyle("Area Style", objstyle1)
        objStyleService.GetStyle("Area Style", objstyle1)
        objstyle1 = objstyle.StyleDefinitions(0).StyleDefinitions(0)
        'Specify boundary style
        objstyleB = objstyle1.StyleDefinitions(0).StyleDefinitions(0)
        objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 35
        objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 0, 182)
        'Specify fill color
        objstyleF = objstyle1.StyleDefinitions(1).StyleDefinitions(0)
        objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(185, 231, 198)
        objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyTranslucency).Value = 35 'Translucidesa
        'Specify Line style
        objStyleService.GetStyle("Linear Style", objstyle2)
        objstyle2 = objstyle.StyleDefinitions(1).StyleDefinitions(0)
        objstyle2.StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 35
        objstyle2.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(109, 78, 10)
        objstyle2.StyleProperties(PView.StylePropertyConstants.gmgroPropertySequenceType).Value = 5 'Segments
        '============================================
        ' Comencem amb la inclusi a la llegenda
        '============================================
        vNameComarca = vGFuncions.DLookup("[NOM_COMAR]", "COMARQUES", "D.[COMARCA]='" & pComarca & "'")
        objRLE = CreateObject("Geomedia.LegendEntry")
        objPropertyTitle.Name = "Title"
        objPropertyTitle.Value = "Grfic " & Trim(vNameComarca)
        With objRLE
            .Name = Trim(vNameComarca)
            .GeometryFieldName = "Geometry"
            .InputRecordset = vGraficPipe.OutputRecordset
            .Style = objstyle
            .PropertySet.Append(objPropertyTitle)
        End With
        MV.Legend.LegendEntries.Append(objRLE, 1)
        objRLE.LoadData()
        MV.Fit()
        MV.Legend.Fit()
        '====================================================

Build_BarChart_Exit:
        'vX = Nothing : vY = Nothing : vZ = Nothing
        vNameComarca = Nothing
        vObj = Nothing : vGFuncions = Nothing
        'vPunts = Nothing
        vPunt = Nothing 'vPuntIniFin = Nothing : vPuntText = Nothing
        'vPunt01 = Nothing : vPunt02 = Nothing : vPunt03 = Nothing
        'vPunt04 = Nothing : vPunt05 = Nothing : vPunt06 = Nothing
        vLinia01h = Nothing
        vLinia02h = Nothing
        vLinia03h = Nothing
        vLinia04h = Nothing
        vPoligon = Nothing
        vColeccio = Nothing
        '====================== Estils: prefixe s
        objstyle1 = Nothing
        objstyle2 = Nothing
        objstyleB = Nothing
        objstyleF = Nothing
        objstyle = Nothing
        '====================== Carpetes d'estil: prefixe f
        objPropertyTitle = Nothing
        objStyleService = Nothing
        objRLE = Nothing
        MV = Nothing
        '====================== Objectes de dades
        GSS = Nothing
        vGraficPipe = Nothing
        vRS = Nothing : vRS2 = Nothing
        vConn = Nothing
        Build_BarChart = vCorrectGrafic
        Exit Function

Error_Build_BarChart:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Build BarChart", 64)
        vCorrectGrafic = False
        'Resume Next
        Resume Build_BarChart_Exit
    End Function

    'Aquest procedimet construeix els poligons representatius dels resultats de cada partit
    '@param pResultats() = array d'una estructura de dades que cont les dades electorals
    '@param pOrigen = objecte que representa el punt d'origen per construir la geometria
    '@param pComarca = Codi de la comarca de la que es construeix la geometria
    Public Function Build_BarOfParties(ByVal pResultats As frmCHARTSDATA.ResultatsPartits, ByVal pOrigen As PBasic.point, _
    ByVal pComarca As String, ByVal numOrdre As Integer) As Boolean
        Dim vConn As vPClient.Connection
        Dim vGraficPipe As vPClient.OriginatingPipe
        Dim vRS As GDO.GRecordset
        Dim GSS As vPClient.GeometryStorageService
        Dim vObj As Object
        Dim vPunt As New PBasic.point
        Dim vPoligon As New PBasic.PolygonGeometry
        Dim strLabel As String 'Variable per recollir els vots de cada Partit
        Dim vXe As Double, vXd As Double, vY As Double, vZ As Double, i As Integer, j As Integer
        Dim vCorrectGrafic As Boolean = True
        Dim vNameComarca As String, vGFuncions = New GeneralFuncions
        '=========================================================
        On Error GoTo Error_Build_BarOfParties
        vConn = gobjGeoApp.Document.Connections(1)
        GSS = gobjGeoApp.CreateService("GeoMedia.GeometryStorageService")
        vPunt = gobjGeoApp.CreateService("GeoMedia.Point")
        vPoligon = gobjGeoApp.CreateService("GeoMedia.PolygonGeometry")
        'Comencem per fer la distribuci dels polgons
        Select Case pResultats.Partit
            Case "PP"
                If numOrdre = 0 Then
                    vXe = pOrigen.X + 10000 - 3000 'Pel primer polgon. els polgons tenen 2500 de amplada
                    'i, per tant queden els extrems a 500 del eix de cada partit
                Else
                    vXd = pOrigen.X + 10000 + 500 'Pel segon polgon
                End If
            Case "CIU"
                If numOrdre = 0 Then
                    vXe = pOrigen.X + 18000 - 3000
                Else
                    vXd = pOrigen.X + 18000 + 500
                End If
            Case "ALTRES"
                If numOrdre = 0 Then
                    vXe = pOrigen.X + 26000 - 3000
                Else
                    vXd = pOrigen.X + 26000 + 500
                End If
            Case "PSC"
                If numOrdre = 0 Then
                    vXe = pOrigen.X + 34000 - 3000
                Else
                    vXd = pOrigen.X + 34000 + 500
                End If
            Case "ERC"
                If numOrdre = 0 Then
                    vXe = pOrigen.X + 42000 - 3000
                Else
                    vXd = pOrigen.X + 42000 + 500
                End If
            Case "IC_V"
                If numOrdre = 0 Then
                    vXe = pOrigen.X + 50000 - 3000
                Else
                    vXd = pOrigen.X + 50000 + 500
                End If
        End Select
        'Despus creem el polgon
        If numOrdre = 0 Then
            For j = 1 To 5 'cada polgon t cinc punts. El primer i l'ultim coincideixen
                Select Case j
                    Case 1
                        vPunt.X = vXe : vPunt.Y = pOrigen.Y 'A baix a l'esquerra
                    Case 2
                        vPunt.X = vXe : vPunt.Y = pOrigen.Y + (pResultats.Vots / pResultats.Votans * modCHARTSDATA.ALTURA_DATOS_EN_GRAFIC) 'A dalt a l'esquerra
                    Case 3
                        vPunt.X = vXe + 2500 : vPunt.Y = pOrigen.Y + (pResultats.Vots / pResultats.Votans * modCHARTSDATA.ALTURA_DATOS_EN_GRAFIC) 'A dalt a la dreta
                    Case 4
                        vPunt.X = vXe + 2500 : vPunt.Y = pOrigen.Y 'A baix a la dreta
                    Case 5
                        vPunt.X = vXe : vPunt.Y = pOrigen.Y 'A baix a l'esquerra
                End Select
                vPoligon.Points.Add(vPunt)
            Next j
        ElseIf numOrdre = 1 Then
            For j = 1 To 5 'cada polgon t cinc punts. El primer i l'ultim coincideixen
                Select Case j
                    Case 1
                        vPunt.X = vXd : vPunt.Y = pOrigen.Y 'A baix a l'esquerra
                    Case 2
                        vPunt.X = vXd : vPunt.Y = pOrigen.Y + (pResultats.Vots / pResultats.Votans * modCHARTSDATA.ALTURA_DATOS_EN_GRAFIC) 'A dalt a l'esquerra
                    Case 3
                        vPunt.X = vXd + 2500 : vPunt.Y = pOrigen.Y + (pResultats.Vots / pResultats.Votans * modCHARTSDATA.ALTURA_DATOS_EN_GRAFIC) 'A dalt a la dreta
                    Case 4
                        vPunt.X = vXd + 2500 : vPunt.Y = pOrigen.Y 'A baix a la dreta
                    Case 5
                        vPunt.X = vXd : vPunt.Y = pOrigen.Y 'A baix a l'esquerra
                End Select
                vPoligon.Points.Add(vPunt)
            Next j
        End If
        ' Arxivem l'objecte a la BD
        GSS.GeometryToStorage(vPoligon, vObj)
        vConn.CreateOriginatingPipe(vGraficPipe)
        With vGraficPipe
            Select Case UCase(Trim(pResultats.Partit))
                Case "PP"
                    .Table = "BarresPp"
                Case "CIU"
                    .Table = "BarresCiu"
                Case "ALTRES"
                    .Table = "BarresAltres"
                Case "PSC"
                    .Table = "BarresPsc"
                Case "ERC"
                    .Table = "BarresErc"
                Case "IC_V"
                    .Table = "BarresIcv"
            End Select
            .GeometryFieldName = "Geometry"
            .Filter = "COMARCA='" & pComarca & "' AND ANYO='" & Trim(Str(pResultats.Anyo)) & "'"
        End With
        vRS = vGraficPipe.OutputRecordset
        If Not vRS.EOF And Not vRS.BOF Then
            vRS.MoveLast() : vRS.MoveFirst()
            With vRS
                .Edit()
                .GFields("NOMBRE_VOTS").Value = Format(pResultats.Vots, "#,##0.")
                .GFields("PERCENTATGE").Value = pResultats.Vots / pResultats.Votans
                .GFields("Geometry").Value = vObj
                .Update()
            End With
        Else
            With vRS
                .AddNew()
                .GFields("COMARCA").Value = pComarca
                .GFields("ANYO").Value = Trim(Str(pResultats.Anyo))
                .GFields("NOMBRE_VOTS").Value = Format(pResultats.Vots, "#,##0.")
                .GFields("PERCENTATGE").Value = pResultats.Vots / pResultats.Votans
                .GFields("Geometry").Value = vObj
                .Update()
            End With
        End If
        '==================================================
        'Collocar les entitats al mapview
        '==================================================
        Dim MV As Intergraph.GeoMedia.MapviewLib.GMMapView
        Dim objRLE As PView.LegendEntry
        Dim objPropertyTitle As New vPClient.GMProperty
        Dim objStyleService As New PView.StyleService
        Dim objstyle As PView.StyleDefinition = Nothing ' pel l'rea
        Dim objstyleB As PView.StyleDefinition ' Boundary style
        Dim objstyleF As PView.StyleDefinition ' Specify fill color
        MV = gobjGeoApp.ActiveWindow.Mapview
        objStyleService.GetStyle("Area Style", objstyle)
        'Specify boundary style
        objstyleB = objstyle.StyleDefinitions(0).StyleDefinitions(0)
        objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 35
        'Specify fill color
        objstyleF = objstyle.StyleDefinitions(1).StyleDefinitions(0)
        objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyTranslucency).Value = 35 'Translucidesa
        Select Case UCase(Trim(pResultats.Partit))
            Case "PP"
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 220, 220) 'For a Boundary Style
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 220, 220) 'For a Fill Style
            Case "CIU"
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(70, 70, 255) 'For a Boundary Style
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(70, 70, 255) 'For a Fill Style
            Case "ALTRES"
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(173, 123, 16) 'For a Boundary Style
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(173, 123, 16) 'For a Fill Style
            Case "PSC"
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 0, 0) 'For a Boundary Style
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(255, 0, 0) 'For a Fill Style
            Case "ERC"
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(249, 244, 0) 'For a Boundary Style
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(249, 244, 0) 'For a Fill Style
            Case "IC_V"
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 182, 0) 'For a Boundary Style
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 182, 0) 'For a Fill Style
        End Select
        '============================================
        ' Comencem amb la inclusi a la llegenda
        '============================================
        objRLE = CreateObject("Geomedia.LegendEntry")
        objPropertyTitle.Name = "Title"
        objPropertyTitle.Value = UCase(Trim(pResultats.Partit)) & " - " & UCase(Trim(pResultats.Anyo))
        With objRLE
            .Name = UCase(Trim(pResultats.Partit)) & " - " & UCase(Trim(pResultats.Anyo))
            .GeometryFieldName = "Geometry"
            .InputRecordset = vGraficPipe.OutputRecordset
            .Style = objstyle
            .PropertySet.Append(objPropertyTitle)
        End With
        MV.Legend.LegendEntries.Append(objRLE, 1)
        objRLE.LoadData()
        MV.Fit()
        MV.Legend.Fit()
        '====================================================

Build_BarOfParties_Exit:
        vXe = Nothing : vXd = Nothing : vY = Nothing : vZ = Nothing
        vObj = Nothing
        vPoligon = Nothing
        '==============================================
        objstyle = Nothing
        objstyleB = Nothing
        objstyleF = Nothing
        objStyleService = Nothing
        objPropertyTitle = Nothing
        objRLE = Nothing
        MV = Nothing
        '==============================================
        GSS = Nothing
        vGraficPipe = Nothing
        vRS = Nothing
        vConn = Nothing
        Build_BarOfParties = vCorrectGrafic
        Exit Function

Error_Build_BarOfParties:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Build Bar Of Parties", 64)
        vCorrectGrafic = False
        'Resume Next
        Resume Build_BarOfParties_Exit
    End Function

    'Aquest procedimet construeix les etiquetes que es posen per identificar els anys de les eleccions.
    'Es colloquen a la part de sota de les barres.
    'La versi 2 posa les etiquetes a sota del grafic, per dins el marc del mateix
    '@param pAnys = matriu amb els anys a tractar
    '@param pOrigen = objecte que representa el punt d'origen per construir la geometria
    '@param pComarca = codi de la comarca tractada
    Public Function Build_TextsOfYearInBarGrafic(ByVal pAnys() As Integer, ByVal pOrigen As PBasic.point, _
    ByVal pComarca As String) As Boolean
        Dim vConn As vPClient.Connection
        Dim vGraficPipe As vPClient.OriginatingPipe
        Dim vDB As GDO.GDatabase
        Dim vRS As GDO.GRecordset
        Dim GSS As vPClient.GeometryStorageService
        Dim vObj As Object
        Dim vText As New PBasic.TextPointGeometry
        Dim vGralFuncions = New GeneralFuncions
        Dim vXe(6) As Double, vXd(6) As Double, vY As Double, vZ As Double, i As Integer, j As Integer
        Dim vPartit As String, strSQL As String
        Dim vCorrectGrafic As Boolean = True
        '=========================================================
        Dim MV As Intergraph.GeoMedia.MapviewLib.GMMapView
        Dim objRLE As PView.LegendEntry
        Dim objPropertyTitle As New vPClient.GMProperty
        Dim objStyleService As PView.StyleService
        Dim objstyle As PView.StyleDefinition
        '=========================================================
        On Error GoTo Error_Build_TextsOfYearInBarGrafic
        vConn = gobjGeoApp.Document.Connections(1)
        GSS = gobjGeoApp.CreateService("GeoMedia.GeometryStorageService")
        vText = gobjGeoApp.CreateService("Geomedia.TextPointGeometry")
        'Cerquem la coordenada x per al rtols: una per cada any
        For i = 0 To UBound(pAnys) - 1
            Select Case i
                Case 0
                    For j = 0 To 5
                        Select Case j
                            Case 0
                                vXe(0) = pOrigen.X + 10000 - 1500 ' PP
                            Case 1
                                vXe(1) = pOrigen.X + 18000 - 1500 ' CIU
                            Case 2
                                vXe(2) = pOrigen.X + 26000 - 1500 ' Altres
                            Case 3
                                vXe(3) = pOrigen.X + 34000 - 1500 ' PSC
                            Case 4
                                vXe(4) = pOrigen.X + 42000 - 1500 ' ERC
                            Case 5
                                vXe(5) = pOrigen.X + 50000 - 1500 ' IC_V
                        End Select
                    Next
                Case 1
                    For j = 0 To 5
                        Select Case j
                            Case 0
                                vXd(0) = pOrigen.X + 10000 + 2000 ' PP
                            Case 1
                                vXd(1) = pOrigen.X + 18000 + 2000 ' CIU
                            Case 2
                                vXd(2) = pOrigen.X + 26000 + 2000 ' Altres
                            Case 3
                                vXd(3) = pOrigen.X + 34000 + 2000 ' PSC
                            Case 4
                                vXd(4) = pOrigen.X + 42000 + 2000 ' ERC
                            Case 5
                                vXd(5) = pOrigen.X + 50000 + 2000 ' IC_V
                        End Select
                    Next
            End Select
        Next
        vY = pOrigen.Y : vZ = pOrigen.Z
        'Ara creem els textPointGeometry i els guardem
        For i = 0 To UBound(pAnys) - 1
            For j = 0 To 5
                If i = 0 Then
                    vText.Origin.X = vXe(j)
                ElseIf i = 1 Then
                    vText.Origin.X = vXd(j)
                End If
                With vText
                    .Origin.Y = vY
                    .Origin.Z = vZ
                    .Normal.I = 0
                    .Normal.J = 0
                    .Normal.K = 1
                    .Alignment = 8 '8= gmaBottomCenter 4= gmaTopCenter 0 = gmaCenterCenter, 1 = gmaCenterLeft; 9=BottomLeft
                    .Rotation = 0
                    .text = Right(Trim(pAnys(i)), 2)
                End With
                'Ara el guardem a la BD "RetolsAnysBarres"
                GSS.GeometryToStorage(vText, vObj)
                'Afegir textos pel quadre general: En primer lloc les etiquetes de les linies horitzontals
                vConn.CreateOriginatingPipe(vGraficPipe)
                With vGraficPipe
                    .Table = "RetolsAnysBarres"
                    .GeometryFieldName = "Geometry"
                    vPartit = vGralFuncions.dlookup("[NOM]", "PARTITS", "D.[ID]=" & j + 1)
                    .Filter = "COMARCA='" & pComarca & "' AND PARTIT='" & vPartit & "' AND ANYO='" & Trim(Str(pAnys(i))) & "'"
                End With
                vRS = vGraficPipe.OutputRecordset
                If Not vRS.BOF And Not vRS.EOF Then
                    vRS.MoveLast() : vRS.MoveFirst()
                    With vRS
                        .Edit()
                        .GFields("Geometry").Value = vObj
                        .Update()
                    End With
                Else
                    With vRS
                        .AddNew()
                        .GFields("COMARCA").Value = pComarca
                        .GFields("PARTIT").Value = vPartit
                        .GFields("ANYO").Value = Trim(Str(pAnys(i)))
                        .GFields("Geometry").Value = vObj
                        .Update()
                    End With
                End If
            Next j
        Next i
        '==================================================
        MV = gobjGeoApp.ActiveWindow.Mapview
        objStyleService = gobjGeoApp.CreateService("GeoMedia.StyleService")
        '======================================================================================
        'Create a text style
        objStyleService.GetStyle("Text Style", objstyle)
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFontName).Value = "Arial"
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFontBold).Value = True
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyFontSize).Value = 380
        objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 0, 182) ' Blau mari
        '==================================================
        ' Collocar les entitats al mapview
        ' Comencem amb la inclusi a la llegenda
        '==================================================
        objRLE = CreateObject("Geomedia.LegendEntry")
        objPropertyTitle.Name = "Title"
        objPropertyTitle.Value = "Retols anys"
        'Filtrem els objectes a mostrar
        '=================================================
        vDB = vConn.Database
        strSQL = "SELECT R.COMARCA, R.PARTIT, R.ANYO, R.Geometry, R.Geometry_SK"
        strSQL = strSQL & " FROM RETOLSANYSBARRES AS R WHERE R.COMARCA='" & pComarca & "';"
        vRS = vDB.OpenRecordset(strSQL, GDO.GConstants.gdbOpenDynaset)
        If Not vRS.BOF And Not vRS.EOF Then
            vRS.MoveLast() : vRS.MoveFirst()
        End If
        '=================================================
        With objRLE
            .Name = "Retols anys"
            .GeometryFieldName = "Geometry"
            .InputRecordset = vRS
            .Style = objstyle
            .PropertySet.Append(objPropertyTitle)
        End With
        MV.Legend.LegendEntries.Append(objRLE, 1)
        objRLE.LoadData()
        MV.Fit()
        MV.Legend.Fit()
        '==================================================

Build_TextsOfYearInBarGrafic_Exit:
        vXe = Nothing : vXd = Nothing : vY = Nothing : vZ = Nothing : i = Nothing : j = Nothing
        vPartit = Nothing
        vObj = Nothing
        vText = Nothing
        MV = Nothing
        objRLE = Nothing
        objPropertyTitle = Nothing
        objStyleService = Nothing
        objstyle = Nothing
        vGralFuncions = Nothing
        GSS = Nothing
        vGraficPipe = Nothing
        vRS = Nothing
        vConn = Nothing
        Build_TextsOfYearInBarGrafic = vCorrectGrafic
        Exit Function

Error_Build_TextsOfYearInBarGrafic:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Build TextsOfYearBar", 64)
        vCorrectGrafic = False
        'Resume Next
        Resume Build_TextsOfYearInBarGrafic_Exit
    End Function
End Class
